package uddi_org.inquiry_v2;

import java.net.MalformedURLException;
import java.util.Vector;

import org.uddi4j.UDDIException;
import org.uddi4j.client.UDDIProxy;
import org.uddi4j.datatype.binding.AccessPoint;
import org.uddi4j.datatype.binding.BindingTemplate;
import org.uddi4j.datatype.binding.BindingTemplates;
import org.uddi4j.datatype.business.BusinessEntity;
import org.uddi4j.datatype.service.BusinessService;
import org.uddi4j.datatype.service.BusinessServices;
import org.uddi4j.response.BindingDetail;
import org.uddi4j.response.BusinessDetail;
import org.uddi4j.response.BusinessDetailExt;
import org.uddi4j.response.RelatedBusinessesList;
import org.uddi4j.response.ServiceDetail;
import org.uddi4j.response.ServiceList;
import org.uddi4j.response.TModelDetail;
import org.uddi4j.response.BusinessList;
import org.uddi4j.response.TModelList;
import org.uddi4j.transport.TransportException;
import org.uddi4j.util.CategoryBag;
import org.uddi4j.util.DiscoveryURLs;
import org.uddi4j.util.FindQualifiers;
import org.uddi4j.util.IdentifierBag;
import org.uddi4j.util.KeyedReference;
import org.uddi4j.util.TModelBag;

import utils.BindingTemplate_TypeMapping;
import utils.BusinessEntity_TypeMapping;
import utils.BusinessService_TypeMapping;
import utils.TModel_TypeMapping;
import utils.Util_TypeMapping;

import uddi_org.api_v2.BindingDetailDocument;
import uddi_org.api_v2.BusinessDetailDocument;
import uddi_org.api_v2.BusinessDetailExtDocument;
import uddi_org.api_v2.BusinessListDocument;
import uddi_org.api_v2.FindBindingDocument;
import uddi_org.api_v2.FindBusinessDocument;
import uddi_org.api_v2.FindRelatedBusinessesDocument;
import uddi_org.api_v2.FindServiceDocument;
import uddi_org.api_v2.FindTModelDocument;
import uddi_org.api_v2.GetBindingDetailDocument;
import uddi_org.api_v2.GetBusinessDetailDocument;
import uddi_org.api_v2.GetBusinessDetailExtDocument;
import uddi_org.api_v2.GetServiceDetailDocument;
import uddi_org.api_v2.GetTModelDetailDocument;
import uddi_org.api_v2.RelatedBusinessesListDocument;
import uddi_org.api_v2.ServiceDetailDocument;
import uddi_org.api_v2.ServiceListDocument;
import uddi_org.api_v2.TModelDetailDocument;
import uddi_org.api_v2.TModelListDocument;

import uddi_org.service.DispositionReportException;
import uddi_org.service.PendingBindingTemplate;
import uddi_org.service.PendingTModel;
import uddi_org.service.ServiceId;
import uddi_org.service.AuditionManager;
import uddi_org.service.WSGuard;
import uddi_org.service.Constants;

/**
 * @author faith
 *
 * Feb 26, 2007  1:48:32 AM
 * 
 * InquireSoapServiceSkeleton.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis2 version: 1.1.1 Jan 09, 2007 (06:20:51 LKT)
 *
 */
public class UDDIInquireServiceSkeleton extends WSGuard implements UDDIInquireServiceSkeletonInterface{

	public UDDIInquireServiceSkeleton()
	{
		super();
	}

	/**
	 * The get_businessDetailExt API call returns extended businessEntity information for one or 
	 * more specified businessEntity registrations. This message returns exactly the same 
	 * information as the get_businessDetail message, but may contain additional attributes if 
	 * the source is an external registry (e.g. not an Operator Site) that is compatible with 
	 * this API specification.
	 * 
	 * 
	 * @param p
	 */
	public BusinessDetailExtDocument get_businessDetailExt(GetBusinessDetailExtDocument p)
	throws DispositionReportException
	{
		BusinessDetailExtDocument returndoc = BusinessDetailExtDocument.Factory.newInstance();
		uddi_org.api_v2.BusinessDetailExt ext = null;
		try {
			Vector v = Util_TypeMapping.toVector(p.getGetBusinessDetailExt().getBusinessKeyArray());
			BusinessDetailExt e = getProxy().get_businessDetailExt(v);
			ext = BusinessEntity_TypeMapping.transformBusinessDetailExt(e);
			returndoc.setBusinessDetailExt(ext);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returndoc;
	}

	/**
	 * The find_relatedBusinesses API call is used to locate information about businessEntity 
	 * registrations that are related to a specific business entity whose key is passed in the 
	 * inquiry. The Related Businesses feature is used to manage registration of business units 
	 * and subsequently relate them based on organizational hierarchies or business partner 
	 * relationships. This returns zero or more relatedBusinessInfo structures. 
	 * For the businessEntity specified in the the response reports complete business relationships 
	 * with other businessEntity registrations. Business relationships are complete between two 
	 * businessEntity registrations when the publishers controlling each of the businessEntity 
	 * structures involved in the relationship set assertions affirming that relationship.
	 * 
	 * @param p
	 */
	public RelatedBusinessesListDocument find_relatedBusinesses(FindRelatedBusinessesDocument p)
	throws DispositionReportException
	{
		RelatedBusinessesListDocument returndoc = RelatedBusinessesListDocument.Factory.newInstance();
		uddi_org.api_v2.RelatedBusinessesList list = null;
		try {
			//checking null arg
			//businessKey id required

			KeyedReference kr = null;
			FindQualifiers fq = null;
			int mr = 0;

			if ((p.getFindRelatedBusinesses().getKeyedReference()) != null)
			{
				kr = Util_TypeMapping.transformKeyedReference(p.getFindRelatedBusinesses().getKeyedReference());
			}
			if ((p.getFindRelatedBusinesses().getFindQualifiers()) != null)
			{
				fq = Util_TypeMapping.transformFindBinding(p.getFindRelatedBusinesses().getFindQualifiers());
			}
			if ((p.getFindRelatedBusinesses().getMaxRows()) > 0)
				mr = p.getFindRelatedBusinesses().getMaxRows();
			//end checking

			RelatedBusinessesList l = getProxy().find_relatedBusinesses
			(p.getFindRelatedBusinesses().getBusinessKey(), kr, fq, mr);

			list = BusinessEntity_TypeMapping.transformRelatedBusinessList(l);
			returndoc.setRelatedBusinessesList(list);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returndoc;
	}

	/**
	 * The get_tModelDetail API call is used to request full information about known 
	 * tModel data by key
	 * 
	 * 
	 * @param p
	 */
	public TModelDetailDocument get_tModelDetail(GetTModelDetailDocument p)
	throws DispositionReportException
	{
		TModelDetailDocument returndoc = TModelDetailDocument.Factory.newInstance();
		uddi_org.api_v2.TModelDetail detail = null;

		try {
			TModelDetail d = getProxy().get_tModelDetail(
					Util_TypeMapping.toVector(p.getGetTModelDetail().getTModelKeyArray()));

			detail = TModel_TypeMapping.transformTModelDetail(d);
			returndoc.setTModelDetail(detail);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returndoc;
	}

	/**
	 * @param p
	 * @return
	 * @throws DispositionReportException
	 * 
	 * The get_businessDetail API call returns complete businessEntity information for one or 
	 * more specified businessEntity registrations matching on the businessKey values specified.
	 */
	public BusinessDetailDocument get_businessDetail(GetBusinessDetailDocument p)
	throws DispositionReportException
	{
		BusinessDetailDocument returndoc = BusinessDetailDocument.Factory.newInstance();
		uddi_org.api_v2.BusinessDetail det = null;
		try {
			BusinessDetail d = getProxy().get_businessDetail(
					Util_TypeMapping.toVector(p.getGetBusinessDetail().getBusinessKeyArray()));
			
			//if the caller is a pending service
			if(isPendingService())
			{
				BusinessEntity entity = null;
				Vector be = d.getBusinessEntityVector();
				BusinessServices bs= null;
				
				for(int i = 0; i<be.size(); i++)
				{
					entity = (BusinessEntity) be.elementAt(i);
					bs = entity.getBusinessServices();
					transformBusinessServiceIntoProxyVersion(bs.getBusinessServiceVector());
				}
			}
			
			det = BusinessEntity_TypeMapping.transformBusinessDetail(d);
			returndoc.setBusinessDetail(det);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returndoc;
	}

	/**
	 * Auto generated method signature
	 * @param p
	 * 
	 * 
	 */
	public TModelListDocument find_tModel(FindTModelDocument p)
	throws DispositionReportException
	{
		TModelListDocument returndoc = TModelListDocument.Factory.newInstance();
		uddi_org.api_v2.TModelList list = null;

		try {

			//start checking
			int mr = 0;
			String name = null;
			CategoryBag cb = null;
			IdentifierBag ib = null;
			FindQualifiers fq = null;

			if((p.getFindTModel().getName())!= null)
				name = p.getFindTModel().getName().getStringValue();

			if((p.getFindTModel().getCategoryBag())!= null)
				cb = Util_TypeMapping.transformCategoryBag(p.getFindTModel().getCategoryBag());

			if((p.getFindTModel().getIdentifierBag())!=null)
				ib =  Util_TypeMapping.transformIdentifierBag(p.getFindTModel().getIdentifierBag());

			if ((p.getFindTModel().getFindQualifiers())!= null);
			fq = Util_TypeMapping.transformFindBinding(p.getFindTModel().getFindQualifiers());

			if ((p.getFindTModel().getMaxRows()) > 0)
				mr = p.getFindTModel().getMaxRows();
			//end checking

			TModelList l = getProxy().find_tModel(name, cb, ib,fq, mr);

			//filter tmodel	

			//get the service group properties
			PendingTModel t = (PendingTModel) this.sgc.getProperty(Constants.PENDINGTMODEL); 
			logger.info(t.toString());
			
			AuditionManager tm =  new AuditionManager();
			tm.setPendingt(t);
			
			Vector news = tm.filterTModel(l.getTModelInfos().getTModelInfoVector());
			logger.info("filter: "+ news.size());

			l.getTModelInfos().setTModelInfoVector(news);

			logger.info(tm.getPendingt().toString());

			list = TModel_TypeMapping.transformTModelList(l);
			returndoc.setTModelList(list);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}	
		return returndoc;
	}


	/**
	 * @param p
	 * @return
	 * @throws DispositionReportException
	 * 
	 * The get_bindingDetail API call is for requesting the run-time bindingTemplate information
	 * for the purpose of invoking a registered business API.
	 * 
	 */
	public BindingDetailDocument get_bindingDetail(GetBindingDetailDocument p)
	throws DispositionReportException
	{
		BindingDetailDocument returndoc = BindingDetailDocument.Factory.newInstance();
		uddi_org.api_v2.BindingDetail detail = null;
		try {
			//call the  uddi4j API
			BindingDetail d = getProxy().get_bindingDetail(
					Util_TypeMapping.toVector(p.getGetBindingDetail().getBindingKeyArray()));

			//if the caller is a pending service
			if(isPendingService()) 
				transformBindingTemplatesIntoProxyVersion(d.getBindingTemplateVector());

			detail = BindingTemplate_TypeMapping.transformBindingDetail(d);

			returndoc.setBindingDetail(detail);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returndoc;
	}

	/**
	 * The find_binding method returns a bindingDetail message that contains a 
	 * bindingTemplates structure with zero or more bindingTemplate structures matching 
	 * the criteria specified in the argument list.
	 *
	 * @param p 
	 * FindBindingDocument is a container for a FindBinding message
	 * FindBinding contains: 
	 * 
	 * findQualifiers - This collection of findQualifier elements can be used to alter the
	 * default behavior of search functionality.
	 * 
	 * serviceKey - Used to specify a particular instance of a businessService element in 
	 * the registered data. Only bindings in the specific businessService data identified by 
	 * the serviceKey passed will be searched.
	 * 
	 * tModelBag - This is a list of tModel uuid_key values that represent the technical 
	 * fingerprint to locate in a bindingTemplate structure contained within the 
	 * businessService instance specified by the serviceKey value. If more than one tModel 
	 * key is specified in this structure, only bindingTemplate information that exactly 
	 * matches all of the tModel keys specified will be returned (logical AND). The order of 
	 * the keys in the tModelBag is not relevant. All tModelKey values begin with a uuid URN 
	 * qualifier (e.g. "uuid:" followed by a known tModel UUID value.
	 * 
	 * maxRows - This optional integer value allows the requesting program to limit the 
	 * number of results returned.
	 * 
	 * @return BindingDetailDocument
	 * This function returns a bindingDetail message on success. In the event that no matches
	 * were located for the specified criteria, the bindingDetail structure returned in the 
	 * response the will be empty (e.g. contain no bindingTemplate data.) In the even of a 
	 * large number of matches, an Operator Site may truncate the result set. If this occurs, 
	 * the response message will contain the truncated attribute with the value of this 
	 * attribute set to true. Searching using tModelBag will also return any bindingTemplate 
	 * information that matches due to hostingRedirector references. The resolved 
	 * bindingTemplate structure will be returned, even if that bindingTemplate is owned by a 
	 * different businessService structure.
	 * 
	 * @throws DispositionReportException
	 * If any error occurs in processing this API call, a dispositionReport element will be 
	 * returned to the caller within a SOAP Fault. The following error number information 
	 * will be relevant:
	 * E_invalidKeyPassed: signifies that the uuid_key value passed did not match with any 
	 * known serviceKey or tModelKey values. The error structure will signify which condition
	 * occurred first, and the invalid key will be indicated clearly in text.
	 * E_unsupported: signifies that one of the findQualifier values passed was invalid. 
	 * The invalid qualifier will be indicated clearly in text.
	 * 
	 */
	public BindingDetailDocument find_binding(FindBindingDocument p)
	throws DispositionReportException
	{
		BindingDetailDocument returndoc = BindingDetailDocument.Factory.newInstance();
		uddi_org.api_v2.BindingDetail detail = null;
		try {

			//checking null parameters

			//serviceKey is a required arg 

			FindQualifiers f = null;
			TModelBag b = null;
			int mr = 0;

			if((p.getFindBinding().getFindQualifiers()) != null)
				f = Util_TypeMapping.transformFindBinding(p.getFindBinding().getFindQualifiers());

			if((p.getFindBinding().getTModelBag()) != null)
				b = TModel_TypeMapping.transformTModelBag(p.getFindBinding().getTModelBag());

			if ((p.getFindBinding().getMaxRows()) > 0)
				mr = p.getFindBinding().getMaxRows();
			//end checking

			/*
			 * recognize if the service that is calling this api
			 * is a service under test (is in pending state)
			 * in that case, instead of the real service, a Proxy service is invoked 
			 */

			//call the uddi4j find API
			BindingDetail d = getProxy().find_binding(f, p.getFindBinding().getServiceKey(), b, mr);

			//pending check
			if(isPendingService()) 		
				//set the Proxy access point
				transformBindingTemplatesIntoProxyVersion(d.getBindingTemplateVector());

			/*
			 * quale di questi risultati invocherà?
			 * 
			 * Non importa, io restituisco a reference to the proxy bt 
			 * per ogni bt trovato dalla find
			 */

			/*
			 * Return a Proxy version of the services found above, 
			 * Proxy services are registered services.
			 * 
			 * "transform" d in a BindigDetail object containing the proxy references
			 * 
			 * return the proxy binding_template
			 * 
			 * DONE for get_bindingDetail
			 * DONE for get_serviceDetail
			 * DONE for get_businessDetail
			 * 
			 */

			detail = BindingTemplate_TypeMapping.transformBindingDetail(d);

			returndoc.setBindingDetail(detail);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returndoc;
	}

	/**
	 * @param p FindServiceDocument
	 * @return ServiceListDocument
	 * @throws DispositionReportException
	 * 
	 * This API call returns a serviceList on success.  
	 * In the event that no matches were located for the specified criteria, 
	 * the serviceList message returned will contain an empty businessServices element.  
	 * This signifies zero matches.  If no search arguments (including businessKey) are passed, 
	 * a zero-match result set will be returned.
	 */
	public ServiceListDocument find_service(FindServiceDocument p)
	throws DispositionReportException
	{
		ServiceListDocument returndoc = ServiceListDocument.Factory.newInstance();
		uddi_org.api_v2.ServiceList list = null;
		try {

			//checking pars
			int mr = 0;
			String bkey = null;
			Vector names = null;
			CategoryBag cb = null;
			TModelBag tb = null;
			FindQualifiers fq = null;

			if((p.getFindService().getBusinessKey()) != null)
				bkey = p.getFindService().getBusinessKey();

			if ((p.getFindService().getNameArray()) != null)
				names = Util_TypeMapping.toVectorN(p.getFindService().getNameArray());

			if((p.getFindService().getCategoryBag())!= null)
				cb = Util_TypeMapping.transformCategoryBag(p.getFindService().getCategoryBag());

			if((p.getFindService().getTModelBag())!=null)
				tb = TModel_TypeMapping.transformTModelBag(p.getFindService().getTModelBag());

			if ((p.getFindService().getFindQualifiers())!= null)
				fq = Util_TypeMapping.transformFindBinding(p.getFindService().getFindQualifiers());

			if ((p.getFindService().getMaxRows()) > 0)
				mr = p.getFindService().getMaxRows();
			//end checking

			ServiceList l = getProxy().find_service(bkey, names, cb, tb, fq, mr);
			list = BusinessService_TypeMapping.transformServiceList(l);
			returndoc.setServiceList(list);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returndoc;
	}

	/**
	 * @param p GetServiceDetailDocument
	 * @return ServiceDetailDocument
	 * @throws DispositionReportException
	 * 
	 * The get_serviceDetail API call is used to request full information about a known 
	 * businessService structure.
	 */
	public ServiceDetailDocument get_serviceDetail(GetServiceDetailDocument p)
	throws DispositionReportException
	{
		ServiceDetailDocument returndoc = ServiceDetailDocument.Factory.newInstance();
		uddi_org.api_v2.ServiceDetail detail = null;
		try {
			ServiceDetail d = getProxy().get_serviceDetail(
					Util_TypeMapping.toVector(p.getGetServiceDetail().getServiceKeyArray()));

			//if the caller is a pending service
			if((isPendingService())) 
				transformBusinessServiceIntoProxyVersion(d.getBusinessServiceVector());

			detail = BusinessService_TypeMapping.transformServiceDetail(d);
			returndoc.setServiceDetail(detail);
		}
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returndoc;
	}


	/**
	 * @param p FindBusinessDocument
	 * @return BusinessListDocument
	 * @throws DispositionReportException
	 * 
	 * In the event that no matches were located for the specified criteria, 
	 * a businessList structure with zero businessInfo structures is returned. 
	 * 
	 * If no arguments are passed, a zero-match result set will be returned.
	 */
	public BusinessListDocument find_business(FindBusinessDocument p)
	throws DispositionReportException
	{
		BusinessListDocument returndoc = BusinessListDocument.Factory.newInstance();
		uddi_org.api_v2.BusinessList list = null;
		try {

			//start checking null pars
			int mr =0;
			Vector names = null;
			DiscoveryURLs disc = null;
			IdentifierBag ib = null;
			CategoryBag cb = null;
			TModelBag tb = null;
			FindQualifiers fq = null;

			if ((p.getFindBusiness().getNameArray()) != null)
				names = Util_TypeMapping.toVectorN(p.getFindBusiness().getNameArray());

			if ((p.getFindBusiness().getDiscoveryURLs())!=null)
				disc = BusinessEntity_TypeMapping.transformDiscoveryURLs(p.getFindBusiness().getDiscoveryURLs());

			if((p.getFindBusiness().getIdentifierBag())!=null)
				ib =  Util_TypeMapping.transformIdentifierBag(p.getFindBusiness().getIdentifierBag());

			if((p.getFindBusiness().getCategoryBag())!= null)
				cb = Util_TypeMapping.transformCategoryBag(p.getFindBusiness().getCategoryBag());

			if((p.getFindBusiness().getTModelBag())!=null)
				tb = TModel_TypeMapping.transformTModelBag(p.getFindBusiness().getTModelBag());

			if ((p.getFindBusiness().getFindQualifiers())!= null)
				fq = Util_TypeMapping.transformFindBinding(p.getFindBusiness().getFindQualifiers());

			if ((p.getFindBusiness().getMaxRows()) > 0)
				mr = p.getFindBusiness().getMaxRows();
			//end checking

			BusinessList l = getProxy().find_business(names, disc, ib, cb, tb, fq, mr);

			list = BusinessEntity_TypeMapping.transformBusinessList(l);
			returndoc.setBusinessList(list);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}	
		return returndoc;
	}


	private void transformBindingTemplatesIntoProxyVersion(Vector d) 
	{
		BindingTemplate template = null;
		String ap = null;
		AccessPoint a = null;
		for(int i =0; i<d.size(); i++)
		{
			template = (BindingTemplate) d.elementAt(i);
			a = template.getAccessPoint();
			ap = template.getAccessPoint().getText()+Constants.PROXY_SUFFIX;
			a.setText(ap);
			template.setAccessPoint(a);
		}
		//return d;
	}
	
	private void transformBusinessServiceIntoProxyVersion(Vector bsv) 
	{
		//Vector bsv = d.getBusinessServiceVector();
		BusinessService bservice = null;
		BindingTemplates bts = null;
		
		for(int i = 0; i<bsv.size(); i++)
		{
			bservice = (BusinessService) bsv.elementAt(i);

			//transform btemplate
			bts = bservice.getBindingTemplates();
			transformBindingTemplatesIntoProxyVersion(bts.getBindingTemplateVector());

		}

	}

	private boolean isPendingService()
	{
		boolean isPending = false;
		String epr = this.inmsgContext.getFrom().getAddress();

		ServiceId serviceid = null;
		PendingBindingTemplate bt = (PendingBindingTemplate) this.sgc.getProperty(Constants.PENDINGBT);

		//TODO: get the bindingType from transport info
		//maybe this in not necessary
		String bindingType = "null";

		if(bindingType == null)
			serviceid = new ServiceId(epr);
		else	
			serviceid = new ServiceId(epr, bindingType);

		//DEBUG ONLY --- REMOVE
		//bt.addBinding(serviceid);

		if (bt.getPendingBindingTemplates().contains(serviceid))
			isPending = true;

		else 
			isPending = false;

		//DEBUG ONLY --- REMOVE
		//bt.removeBinding(serviceid);
		
		
		///////////////debug only 
	/*	String remoteAddress = (String)this.inmsgContext.getProperty("REMOTE_ADDR");
		logger.info("remote addr: "+remoteAddress);

		//TRANSPORT_URL 
		TransportHeaders transport = (TransportHeaders)inmsgContext.getProperty(MessageContext.TRANSPORT_HEADERS);
		String trh = "";
		trh = "Message Context Transport Header Propertie Keys: " +
		transport.keySet() +"\nvalues: "+transport.values();
		logger.info(trh);

		String faddr = (String) inmsgContext.getProperty(AddressingConstants.WSA_FROM);
		if(faddr != null)
			logger.info("ws from "+faddr);
		String taddr = (String) inmsgContext.getProperty(AddressingConstants.WSA_TO);
		if(taddr != null)
			logger.info("ws to "+taddr);*/
		/////////////////

		return isPending;
	}
	
	public static UDDIProxy getProxy()
	{
		UDDIProxy proxy = new UDDIProxy();
		try {
			proxy.setInquiryURL(Constants.INQUIRY_URL_STRING);
			proxy.setPublishURL(Constants.PUBLISH_URL_STRING);
		} catch (MalformedURLException e) {logger.info(e.getMessage());}
		return proxy;
	}
}