package uddi_org.publication_v2;

import java.net.MalformedURLException;
import java.util.Vector;

import org.uddi4j.UDDIException;
import org.uddi4j.client.UDDIProxy;
import org.uddi4j.response.AssertionStatusReport;
import org.uddi4j.response.AuthToken;
import org.uddi4j.response.BindingDetail;
import org.uddi4j.response.BusinessDetail;
import org.uddi4j.response.DispositionReport;
import org.uddi4j.response.PublisherAssertions;
import org.uddi4j.response.RegisteredInfo;
import org.uddi4j.response.ServiceDetail;
import org.uddi4j.response.TModelDetail;
import org.uddi4j.response.TModelInfo;
import org.uddi4j.response.TModelInfos;
import org.uddi4j.transport.TransportException;

import uddi_org.api_v2.AddPublisherAssertionsDocument;
import uddi_org.api_v2.AssertionStatusReportDocument;
import uddi_org.api_v2.AuthTokenDocument;
import uddi_org.api_v2.BindingDetailDocument;
import uddi_org.api_v2.BusinessDetailDocument;
import uddi_org.api_v2.DeleteBindingDocument;
import uddi_org.api_v2.DeleteBusinessDocument;
import uddi_org.api_v2.DeletePublisherAssertionsDocument;
import uddi_org.api_v2.DeleteServiceDocument;
import uddi_org.api_v2.DeleteTModelDocument;
import uddi_org.api_v2.DiscardAuthTokenDocument;
import uddi_org.api_v2.DispositionReportDocument;
import uddi_org.api_v2.GetAssertionStatusReportDocument;
import uddi_org.api_v2.GetPublisherAssertionsDocument;
import uddi_org.api_v2.GetRegisteredInfoDocument;
import uddi_org.api_v2.PublisherAssertionsDocument;
import uddi_org.api_v2.RegisteredInfoDocument;
import uddi_org.api_v2.SaveBindingDocument;
import uddi_org.api_v2.SaveBusinessDocument;
import uddi_org.api_v2.SaveServiceDocument;
import uddi_org.api_v2.SaveTModelDocument;
import uddi_org.api_v2.ServiceDetailDocument;
import uddi_org.api_v2.SetPublisherAssertionsDocument;
import uddi_org.api_v2.TModelDetailDocument;

import utils.BindingTemplate_TypeMapping;
import utils.BusinessEntity_TypeMapping;
import utils.BusinessService_TypeMapping;
import utils.PublisherAssertions_TypeMapping;
import utils.TModel_TypeMapping;
import utils.Util_TypeMapping;

import uddi_org.service.PendingBindingTemplate;
import uddi_org.service.PendingTModel;
import uddi_org.service.WSGuard;
import uddi_org.service.AuditionManager;
import uddi_org.service.DispositionReportException;
import uddi_org.service.TModelKey;
import uddi_org.service.Constants;

/**
 * @author faith
 *
 * Feb 26, 2007  1:48:44 AM
 * 
 * PublishSoapServiceSkeleton.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis2 version: 1.1.1 Jan 09, 2007 (06:20:51 LKT)
 *
 */

public class UDDIPublishServiceSkeleton extends WSGuard implements UDDIPublishServiceSkeletonInterface{

	public UDDIPublishServiceSkeleton()
	{
		super();
	}

	/**
	 * The get_registeredInfo message is used to get an abbreviated list of all businessEntity 
	 * keys and tModel keys that are controlled by the individual associated the credentials 
	 * passed.
	 * 
	 * @param p GetRegisteredInfoDocument object containing an authentication token.
	 * @return RegisteredInfoDocument
	 * @throws DispositionReportException
	 */
	public RegisteredInfoDocument get_registeredInfo(GetRegisteredInfoDocument p)
	throws DispositionReportException
	{
		RegisteredInfoDocument returnr = RegisteredInfoDocument.Factory.newInstance();
		uddi_org.api_v2.RegisteredInfo info = null;
		try {
			RegisteredInfo r = getProxy().get_registeredInfo(p.getGetRegisteredInfo().getAuthInfo());
			
			Vector tmodelinfov = r.getTModelInfos().getTModelInfoVector();
			Vector newtmodelinfov = new Vector();
			TModelInfo tmodelinfo = null;
			String tmodelkey = null;
			boolean isPending = false;
			
			//filter all pending tmodels
			
			//get the service group property 
			PendingTModel tm = (PendingTModel) this.sgc.getProperty(Constants.PENDINGTMODEL);
		
			for(int i =0; i<tmodelinfov.size(); i++)
			{
				tmodelinfo = (TModelInfo)tmodelinfov.elementAt(i);
				tmodelkey = tmodelinfo.getTModelKey();
				isPending = tm.getPendingTModels().contains(new TModelKey(tmodelkey));
				
				if (! isPending)
					newtmodelinfov.add(tmodelinfo);
			}
			
			TModelInfos newinfos = new TModelInfos();
			newinfos.setTModelInfoVector(newtmodelinfov);
			r.setTModelInfos(newinfos);
		
			info = PublisherAssertions_TypeMapping.transformTo(r);
			returnr.setRegisteredInfo(info);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returnr;
	}

	/**
	 * The delete_business message is used to remove one or more businessEntity structures.
	 * 
	 * @param p an authentication token and a vector of uuid_key strings that represent 
	 * specific instances of known businessEntity data.
	 * @return Upon successful completion, a dispositionReport is returned with a 
	 * single success indicator
	 * @throws DispositionReportException
	 */
	public DispositionReportDocument delete_business(DeleteBusinessDocument p)
	throws DispositionReportException
	{
		DispositionReportDocument returnd = DispositionReportDocument.Factory.newInstance();
		uddi_org.api_v2.DispositionReport disposition = null;
		try {

			DispositionReport d = getProxy().delete_business(
					p.getDeleteBusiness().getAuthInfo(), 
					Util_TypeMapping.toVector(p.getDeleteBusiness().getBusinessKeyArray()));

			disposition = Util_TypeMapping.transformDispositionReport(d);
			returnd.setDispositionReport(disposition);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returnd;
	}

	/**
	 * The delete_tModel message is used to remove or retire one or more tModel structures.
	 * 
	 * @param p
	 * @return
	 * @throws DispositionReportException
	 */
	public DispositionReportDocument delete_tModel(DeleteTModelDocument p)
	throws DispositionReportException
	{
		DispositionReportDocument returnd = DispositionReportDocument.Factory.newInstance();
		uddi_org.api_v2.DispositionReport disposition = null;
		try {

			DispositionReport d = getProxy().delete_tModel(
					p.getDeleteTModel().getAuthInfo(), 
					Util_TypeMapping.toVector(p.getDeleteTModel().getTModelKeyArray()));

			disposition = Util_TypeMapping.transformDispositionReport(d);
			returnd.setDispositionReport(disposition);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}	
		return returnd;
	}

	/**
	 * @param p
	 * @return
	 * @throws DispositionReportException
	 */
	public DispositionReportDocument delete_publisherAssertions(DeletePublisherAssertionsDocument p)
	throws DispositionReportException
	{
		DispositionReportDocument returnd = DispositionReportDocument.Factory.newInstance();
		uddi_org.api_v2.DispositionReport disposition = null;
		try {

			DispositionReport d = getProxy().delete_publisherAssertions(
					p.getDeletePublisherAssertions().getAuthInfo(),
					PublisherAssertions_TypeMapping.toVector(p.getDeletePublisherAssertions().getPublisherAssertionArray()));

			disposition = Util_TypeMapping.transformDispositionReport(d);
			returnd.setDispositionReport(disposition);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returnd;
	}

	/**
	 * @param p
	 * @return
	 * @throws DispositionReportException
	 */
	public PublisherAssertionsDocument set_publisherAssertions(SetPublisherAssertionsDocument p)
	throws DispositionReportException
	{
		PublisherAssertionsDocument returndoc = PublisherAssertionsDocument.Factory.newInstance();
		uddi_org.api_v2.PublisherAssertions assertions = null;
		try {
			uddi_org.api_v2.PublisherAssertion[] array = p.getSetPublisherAssertions().getPublisherAssertionArray();

			PublisherAssertions ass = getProxy().set_publisherAssertions(
					p.getSetPublisherAssertions().getAuthInfo(),
					PublisherAssertions_TypeMapping.toVector(array));

			assertions = PublisherAssertions_TypeMapping.transformPublisherAssertions(ass);
			returndoc.setPublisherAssertions(assertions);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returndoc;
	}

	/**
	 * @param p
	 * @return
	 * @throws DispositionReportException
	 */
	public DispositionReportDocument add_publisherAssertions(AddPublisherAssertionsDocument p)
	throws DispositionReportException
	{
		DispositionReportDocument returnd = uddi_org.api_v2.DispositionReportDocument.Factory.newInstance();
		uddi_org.api_v2.DispositionReport disposition = null;
		try {
			Vector v = PublisherAssertions_TypeMapping.toVector(p.getAddPublisherAssertions().getPublisherAssertionArray());

			DispositionReport d = getProxy().add_publisherAssertions(
					p.getAddPublisherAssertions().getAuthInfo(), 
					v);

			disposition = Util_TypeMapping.transformDispositionReport(d);
			returnd.setDispositionReport(disposition);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returnd;
	}

	/**
	 * @param p
	 * @return
	 * @throws DispositionReportException
	 */
	public  uddi_org.api_v2.AuthTokenDocument get_authToken(uddi_org.api_v2.GetAuthTokenDocument p)
	throws DispositionReportException
	{
		uddi_org.api_v2.AuthTokenDocument returnTokenContainer =AuthTokenDocument.Factory.newInstance();
		uddi_org.api_v2.AuthToken returnToken = returnTokenContainer.addNewAuthToken();
		try {

			AuthToken token = getProxy().get_authToken(p.getGetAuthToken().getUserID(), p.getGetAuthToken().getCred());

			returnToken.setAuthInfo(token.getAuthInfoString());
			returnToken.setGeneric(AuthToken.GENERIC);
			returnToken.setOperator(token.getOperator());
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}

		return returnTokenContainer;
	}

	/**
	 * @param p
	 * @return
	 * @throws DispositionReportException
	 */
	public ServiceDetailDocument save_service(SaveServiceDocument p)
	throws DispositionReportException
	{
		ServiceDetailDocument returndoc = ServiceDetailDocument.Factory.newInstance();
		uddi_org.api_v2.ServiceDetail detail = null;
		ServiceDetail d = null;

		uddi_org.api_v2.BusinessService[] array = p.getSaveService().getBusinessServiceArray();
		Vector services = BusinessService_TypeMapping.toVectorBusinessService(array);

		//get the service group properties
		PendingTModel t = (PendingTModel) this.sgc.getProperty(Constants.PENDINGTMODEL);
		PendingBindingTemplate bt = (PendingBindingTemplate) this.sgc.getProperty(Constants.PENDINGBT); 
		
		AuditionManager tm =  new AuditionManager();
		try {
			tm.setPendingbt(bt);
			tm.setPendingt(t);
			
			tm.businessServiceTesting(p.getSaveService().getAuthInfo(), services);

			if (tm.isAllServiceTestok())
			{
				logger.info("UDDIPublishService: all service test ok");
				d = new ServiceDetail();
				d.setBusinessServiceVector(tm.getServiceDetailVector());
				detail = BusinessService_TypeMapping.transformServiceDetail(d);
				returndoc.setServiceDetail(detail);
			}
			else
			{
				logger.info("UDDIPublishService: NOT all service test ok");
				DispositionReportException dre = Util_TypeMapping.buildDispositionReportException
				(tm.getServiceDispositionReport());
				this.sgc.setProperty(Constants.PENDINGBT, tm.getPendingbt());
				this.sgc.setProperty(Constants.PENDINGTMODEL, tm.getPendingt());
				throw dre;
			}
		}	catch (TransportException e) {logger.info(e.toString());}
		this.sgc.setProperty(Constants.PENDINGBT, tm.getPendingbt());
		this.sgc.setProperty(Constants.PENDINGTMODEL, tm.getPendingt());
		return returndoc;
	}

	/**
	 * @param p
	 * @return
	 * @throws DispositionReportException
	 */
	public AssertionStatusReportDocument get_assertionStatusReport(GetAssertionStatusReportDocument p)
	throws DispositionReportException
	{
		AssertionStatusReportDocument returna = AssertionStatusReportDocument.Factory.newInstance();
		uddi_org.api_v2.AssertionStatusReport assertion = null;
		try {

			AssertionStatusReport d = getProxy().get_assertionStatusReport(
					p.getGetAssertionStatusReport().getAuthInfo(), 
					p.getGetAssertionStatusReport().getCompletionStatus());

			assertion = PublisherAssertions_TypeMapping.transformAssertionStatusReport(d);
			returna.setAssertionStatusReport(assertion);
		}	
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returna;
	}

	/**
	 * @param p
	 * @return
	 * @throws DispositionReportException
	 */
	public PublisherAssertionsDocument get_publisherAssertions(GetPublisherAssertionsDocument p)
	throws DispositionReportException
	{
		PublisherAssertionsDocument returndoc = uddi_org.api_v2.PublisherAssertionsDocument.Factory.newInstance();
		uddi_org.api_v2.PublisherAssertions ass = null;
		try {
			PublisherAssertions d = getProxy().get_publisherAssertions(
					p.getGetPublisherAssertions().getAuthInfo());

			ass = PublisherAssertions_TypeMapping.transformPublisherAssertions(d);
			returndoc.setPublisherAssertions(ass);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returndoc;
	}

	/**
	 * @param p
	 * @return
	 * @throws DispositionReportException
	 */
	public BindingDetailDocument save_binding(SaveBindingDocument p)
	throws DispositionReportException
	{
		//logger.info("IN save_bind");
		BindingDetailDocument returndoc = BindingDetailDocument.Factory.newInstance();
		uddi_org.api_v2.BindingDetail detail = null;
		BindingDetail d = null;

		Vector templateVector = BindingTemplate_TypeMapping.toVector(p.getSaveBinding().getBindingTemplateArray());
		AuditionManager tm =  new AuditionManager();
		
		try {
			//get the service group properties
			PendingTModel t = (PendingTModel) this.sgc.getProperty(Constants.PENDINGTMODEL);
			PendingBindingTemplate bt = (PendingBindingTemplate) this.sgc.getProperty(Constants.PENDINGBT);
			
			tm.setPendingbt(bt);
			tm.setPendingt(t);
			
			tm.bindingTemplateTesting(p.getSaveBinding().getAuthInfo(), templateVector);

			if (tm.isAllBindingTestok())
			{
				logger.info("UDDIPublishService: all test ok");
				d = new BindingDetail();
				d.setBindingTemplateVector(tm.getBindingDetailVector());
				detail = BindingTemplate_TypeMapping.transformBindingDetail(d);
				returndoc.setBindingDetail(detail);
			}
			else
			{
				logger.info("UDDIPublishService: NOT all test ok");
				DispositionReportException dre = Util_TypeMapping.buildDispositionReportException
				(tm.getBindingDispositionReport());
				this.sgc.setProperty(Constants.PENDINGBT, tm.getPendingbt());
				this.sgc.setProperty(Constants.PENDINGTMODEL, tm.getPendingt());
				throw dre;
			}
		}catch (TransportException e) {logger.info(e.toString());}
		this.sgc.setProperty(Constants.PENDINGBT, tm.getPendingbt());
		this.sgc.setProperty(Constants.PENDINGTMODEL, tm.getPendingt());
		//super.testingManager = tm;
		return returndoc;
	}



	/**
	 * @param p
	 * @return
	 * @throws DispositionReportException
	 */
	public DispositionReportDocument discard_authToken(DiscardAuthTokenDocument p)
	throws DispositionReportException
	{
		DispositionReportDocument returnd = DispositionReportDocument.Factory.newInstance();
		uddi_org.api_v2.DispositionReport disposition = null;
		try {
			DispositionReport d = getProxy().discard_authToken(p.getDiscardAuthToken().getAuthInfo());
			disposition = Util_TypeMapping.transformDispositionReport(d);
			returnd.setDispositionReport(disposition);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returnd;
	}

	/**
	 * @param p Contains an authentication token and a Vector of businessEntity objects.
	 * @return This API returns a businessDetail message containing the final results of 
	 * the call that reflects the new registered information for the businessEntity information 
	 * provided.
	 * @throws DispositionReportException A dispositionReport element will be returned to the caller within a SOAP Fault:
	 * <ul> 
	 * <li>if any error occurs in processing this API call;
	 * <li>if at least one of the bt to save fails the testing phase.
	 * </ul>
	 * 
	 * The save_business message is used to save or update information about a complete
	 * businessEntity structure. This API has the broadest scope of all of the save_x API 
	 * calls in the publisher API, and can be used to make sweeping changes to the published 
	 * information for one or more businessEntity structures controlled by an individual.
	 * 
	 *
	 * 
	 */
	public BusinessDetailDocument save_business(SaveBusinessDocument p)
	throws DispositionReportException
	{
		BusinessDetailDocument returndoc = BusinessDetailDocument.Factory.newInstance();
		uddi_org.api_v2.BusinessDetail detail = null;
		BusinessDetail d = null;

		Vector v = BusinessEntity_TypeMapping.toVector(p.getSaveBusiness().getBusinessEntityArray());

		//get the service group properties
		PendingTModel t = (PendingTModel) this.sgc.getProperty(Constants.PENDINGTMODEL);
		PendingBindingTemplate bt = (PendingBindingTemplate) this.sgc.getProperty(Constants.PENDINGBT); 
		
		AuditionManager tm =  new AuditionManager();
		
		try {
			tm.setPendingbt(bt);
			tm.setPendingt(t);
			
			tm.businessEntityTesting(p.getSaveBusiness().getAuthInfo(), v);

			if (tm.isAllBusinessTestok())
			{
				logger.info("UDDIPublishService: all business test ok");
				d = new BusinessDetail();
				d.setBusinessEntityVector(tm.getBusinessDetailVector());
				detail = BusinessEntity_TypeMapping.transformBusinessDetail(d);;
				returndoc.setBusinessDetail(detail);
			}
			else
			{
				logger.info("UDDIPublishService: NOT all business test ok");
				DispositionReportException dre = Util_TypeMapping.buildDispositionReportException
																		(tm.getBusinessDispositionReport());
				this.sgc.setProperty(Constants.PENDINGBT, tm.getPendingbt());
				this.sgc.setProperty(Constants.PENDINGTMODEL, tm.getPendingt());
				throw dre;
			}
		}catch (TransportException e) {logger.info(e.toString());}
		
		this.sgc.setProperty(Constants.PENDINGBT, tm.getPendingbt());
		this.sgc.setProperty(Constants.PENDINGTMODEL, tm.getPendingt());
		return returndoc;
	}

	/**
	 * @param p
	 * @return
	 * @throws DispositionReportException
	 */
	public DispositionReportDocument delete_binding(DeleteBindingDocument p)
	throws DispositionReportException
	{
		DispositionReportDocument returnd = DispositionReportDocument.Factory.newInstance();
		uddi_org.api_v2.DispositionReport disposition = null;
		try {

			DispositionReport d = getProxy().delete_binding(
					p.getDeleteBinding().getAuthInfo(), 
					Util_TypeMapping.toVector(p.getDeleteBinding().getBindingKeyArray()));

			disposition = Util_TypeMapping.transformDispositionReport(d);
			returnd.setDispositionReport(disposition);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returnd;
	}

	/**
	 * @param p
	 * @return
	 * @throws DispositionReportException
	 * 
	 * TODO delete the relative tmodel service: not sure
	 */
	public DispositionReportDocument delete_service(DeleteServiceDocument p)
	throws DispositionReportException
	{
		DispositionReportDocument returnd = DispositionReportDocument.Factory.newInstance();
		uddi_org.api_v2.DispositionReport disposition = null;
		try {

			DispositionReport d = getProxy().delete_service(
					p.getDeleteService().getAuthInfo(),
					Util_TypeMapping.toVector(p.getDeleteService().getServiceKeyArray()));

			disposition = Util_TypeMapping.transformDispositionReport(d);
			returnd.setDispositionReport(disposition);
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		return returnd;
	}

	/**
	 * @param p
	 * @return
	 * @throws DispositionReportException
	 */
	public TModelDetailDocument save_tModel(SaveTModelDocument p)
	throws DispositionReportException
	{
		TModelDetailDocument returndoc = TModelDetailDocument.Factory.newInstance();
		uddi_org.api_v2.TModelDetail detail = null;

		//get the service group properties
		PendingTModel t = (PendingTModel) this.sgc.getProperty(Constants.PENDINGTMODEL); 
		
		AuditionManager tm =  new AuditionManager();
		logger.info(t.toString());
		
		try {
			tm.setPendingt(t);
			
			//save tModel
			uddi_org.api_v2.TModel[] tmodel = p.getSaveTModel().getTModelArray();
			TModelDetail d = getProxy().save_tModel(
					p.getSaveTModel().getAuthInfo(),  TModel_TypeMapping.toVectorTM(tmodel));

			detail = TModel_TypeMapping.transformTModelDetail(d);
			returndoc.setTModelDetail(detail);

			/*
			 * mark *only* tmodel-binding and tmodel-service as "pending"
			 * these tmodels cannot be found with find_tModel api
			 * 
			 * add a filter in find_tModel
			 * doesn't matter to filter the get_tModelDetail api results, since no one will be able
			 * to find out the tModel key (drill-down pattern, cfr UDDIv2 spec)
			 */
			tm.marktModelAsPending(d.getTModelVector());
			
		} 
		catch (UDDIException e) {
			//throw a new DispositionReportException
			DispositionReportException dre = Util_TypeMapping.checkUDDIException(e);
			throw dre;	} 
		catch (TransportException e) {logger.info(e.toString());}
		sgc.setProperty(Constants.PENDINGTMODEL, tm.getPendingt());
		logger.info(tm.getPendingt().toString());
		return returndoc;
	}

	public static UDDIProxy getProxy()
	{
		UDDIProxy proxy = new UDDIProxy();
		try {
			proxy.setInquiryURL(Constants.INQUIRY_URL_STRING);
			proxy.setPublishURL(Constants.PUBLISH_URL_STRING);
		} catch (MalformedURLException e) {logger.info(e.getMessage());}
		return proxy;
	}
	
	
	
}