package uddi_org.service;

/**
 * @author faith
 *
 * Mar 15, 2007  12:46:22 AM
 *
 */

/*
 * AUDITION (the registry WS-GUARD) invokes at AMBITION (the testing tool) a testing method 
 * providing the following 4 parameters:
 * <ol>
 * <li> URL to an SP-SSM instance
 * <li> URL to a concrete WSDL (which refers to an abstract WSDL)
 * this is the URL of the WSDL document containing the wsdl:service element
 * supposed to be the same document containing the wsdl:binding element for the moment
 * the WSDL-UDDI mapping seems to support modelling the WSDL location of wsdl:service element
 * but it doesn't show HOW  - RISOLTO  
 * <li> The QName of a Service
 * <li> The QName of a Port
 */

public class AmbitionPars{

	private String serviceLocalName;
	private String portLocalName;
	private String serviceNamespace;

	//maybe only serviceName and portName are really needed
	private String portTypeName;
	private String bindingName;

	private String accessPoint;
	
	private String wsdlURI;
	private String ssmURI;
	
	private ServiceId serviceId;

	/**
	 * Default constructor
	 */
	public AmbitionPars()
	{
		
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString()
	{
		String s =  "serviceName:	 "+this.serviceLocalName+"\n" +
					"serviceNamespace:	 "+this.serviceNamespace+"\n" +
					"portName:  	 "+this.portLocalName+"\n" +
					"portTypeName:   "+this.portTypeName+"\n" +
					"bindingName:    "+this.bindingName+"\n" +
					"accessPoint:    "+this.accessPoint+"\n" +
					"wsdlURI:        "+this.wsdlURI+"\n" +
					"ssmURI:		 "+this.ssmURI+"\n" +	
					"serviceId:      "+this.serviceId.getUri();
					
		return s;
	}
	
	/*
	 * getters and setters
	 */
	public ServiceId getServiceId() {
		return serviceId;
	}
	
	public void setServiceId(ServiceId serviceId) {
		this.serviceId = serviceId;
	}
	
	public String getAccessPoint() {
		return accessPoint;
	}
	
	public void setAccessPoint(String accessPoint) {
		this.accessPoint = accessPoint;
	}
	
	public String getBindingName() {
		return bindingName;
	}
	
	public void setBindingName(String bindingName) {
		this.bindingName = bindingName;
	}
	
	public String getPortTypeName() {
		return portTypeName;
	}
	
	public void setPortTypeName(String portTypeName) {
		this.portTypeName = portTypeName;
	}
	
	public String getServiceLocalName() {
		return serviceLocalName;
	}
	public void setServiceLocalName(String serviceLocalName) {
		this.serviceLocalName = serviceLocalName;
	}

	public String getServiceNamespace() {
		return serviceNamespace;
	}

	public void setServiceNamespace(String serviceNamespace) {
		this.serviceNamespace = serviceNamespace;
	}

	public String getWsdlURI() {
		return wsdlURI;
	}
	
	public void setWsdlURI(String wsdlURI) {
		this.wsdlURI = wsdlURI;
	}
	
	public String getSsmURI() {
		return ssmURI;
	}
	
	public void setSsmURI(String ssmURI) {
		this.ssmURI = ssmURI;
	}

	public String getPortLocalName() {
		return portLocalName;
	}

	public void setPortLocalName(String portLocalName) {
		this.portLocalName = portLocalName;
	}
}