package uddi_org.service;

import java.io.IOException;
import java.util.logging.FileHandler;
import java.util.logging.Formatter;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.logging.SimpleFormatter;
import org.apache.axis2.AxisFault;
import org.apache.axis2.context.MessageContext;
import org.apache.axis2.context.OperationContext;
import org.apache.axis2.context.ServiceGroupContext;

/**
 * @author faith  
 * 
 * Mar 2, 2007  6:02:10 PM
 */
public class WSGuard{

	//messageContext vars
	protected MessageContext inmsgContext = null;
	protected MessageContext outmsgContext = null;
	protected ServiceGroupContext sgc = null;

	//logger vars
	protected static Logger logger = Logger.getLogger("WsGuard");
	protected static FileHandler fh;

	protected WSGuard()
	{
		//init logger
		try {
			if (fh ==null) {
				fh = new FileHandler("/home/faith/workspace/UDDIProxyWS/WsGuard.log");
				Formatter fmt = new SimpleFormatter();
				fh.setFormatter(fmt);
				logger.addHandler(fh);
				logger.setLevel(Level.ALL);
			}
		}catch(IOException e) {return;}
		logger.info("WsGuard init");
	

		//contexts
		MessageContext msgCtx = MessageContext.getCurrentMessageContext();
		OperationContext opCtx = msgCtx.getOperationContext();
		try {
			inmsgContext = opCtx.getMessageContext("In");
			outmsgContext = opCtx.getMessageContext("Out");
			sgc = inmsgContext.getServiceGroupContext();
		} catch (AxisFault e) {return;}

		if (inmsgContext==null)
		{
			logger.info("IN message Context is null");
			return; 
		}

		if (outmsgContext==null)
		{
			logger.info("OUT message Context is null");
			return;
		}

		if(sgc == null)
		{
			logger.info("Service Group Context is null");
			return;
		}
		
		/*
		 * initialize serviceGroupContext properties:
		 * - PendingTModel
		 * - PendingBindingTemplate
		 */
		
		//PendingTModel
		PendingTModel pendingt = (PendingTModel) sgc.getProperty(Constants.PENDINGTMODEL);
		if(pendingt == null)
		{
			logger.info("WsGuard: created new pending tmodel");
			pendingt = new PendingTModel();
			sgc.setProperty(Constants.PENDINGTMODEL, pendingt);
		}
		
		//PendingBindingTemplate
		PendingBindingTemplate pendingbt = (PendingBindingTemplate) sgc.getProperty(Constants.PENDINGBT);
		if(pendingbt == null)
		{
			logger.info("WsGuard: created new pending bt");
			pendingbt = new PendingBindingTemplate();
			sgc.setProperty(Constants.PENDINGBT, pendingbt);
		}
	}
}

