package uddi_org.uddi_client;

import uddi_org.api_v2.BindingDetail;
import uddi_org.api_v2.BindingDetailDocument;
import uddi_org.api_v2.BindingTemplate;
import uddi_org.api_v2.BusinessDetailDocument;
import uddi_org.api_v2.BusinessEntity;
import uddi_org.api_v2.BusinessInfo;
import uddi_org.api_v2.BusinessListDocument;
import uddi_org.api_v2.BusinessService;
import uddi_org.api_v2.FindBinding;
import uddi_org.api_v2.FindBindingDocument;
import uddi_org.api_v2.FindBusiness;
import uddi_org.api_v2.FindBusinessDocument;
import uddi_org.api_v2.FindRelatedBusinesses;
import uddi_org.api_v2.FindRelatedBusinessesDocument;
import uddi_org.api_v2.FindService;
import uddi_org.api_v2.FindServiceDocument;
import uddi_org.api_v2.FindQualifiers;
import uddi_org.api_v2.FindTModel;
import uddi_org.api_v2.FindTModelDocument;
import uddi_org.api_v2.GetBindingDetail;
import uddi_org.api_v2.GetBindingDetailDocument;
import uddi_org.api_v2.GetBusinessDetail;
import uddi_org.api_v2.GetBusinessDetailDocument;
import uddi_org.api_v2.GetServiceDetail;
import uddi_org.api_v2.GetServiceDetailDocument;
import uddi_org.api_v2.GetTModelDetail;
import uddi_org.api_v2.GetTModelDetailDocument;
import uddi_org.api_v2.Name;
import uddi_org.api_v2.RelatedBusinessInfo;
import uddi_org.api_v2.RelatedBusinessesList;
import uddi_org.api_v2.RelatedBusinessesListDocument;
import uddi_org.api_v2.ServiceDetailDocument;
import uddi_org.api_v2.ServiceInfo;
import uddi_org.api_v2.ServiceListDocument;
import uddi_org.api_v2.TModel;
import uddi_org.api_v2.TModelDetail;
import uddi_org.api_v2.TModelDetailDocument;
import uddi_org.api_v2.TModelInfo;
import uddi_org.api_v2.TModelList;
import uddi_org.api_v2.TModelListDocument;
import uddi_org.service.DispositionReportException;
import uddi_org.inquiry_v2.UDDIInquireServiceSkeleton;


public class MainClientInquiry {
	public static void main(String args[])
	{
		try {
			UDDIInquireServiceSkeleton p = new UDDIInquireServiceSkeleton();

			
			//findBusiness(p);
			//findService(p);
			findTModel(p);
			//findBinding(p);
			//findRelatedBusinesses(p);
			//getBindingDetail(p);
			//getBusinessDetail(p);
			//getServiceDetail(p);
			//gettmodelDetail(p);

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private static void gettmodelDetail(UDDIInquireServiceSkeleton p) 
	{
		GetTModelDetailDocument tc = GetTModelDetailDocument.Factory.newInstance();
		GetTModelDetail t = tc.addNewGetTModelDetail();
		
		t.setGeneric("2.0");
		String[] keys = new String[] {"uuid:C0E6FAD0-807A-11DB-B091-F3DF85F15465"}; 
		t.setTModelKeyArray(keys);
		
		TModelDetailDocument response = null;
		
		try {
			response = p.get_tModelDetail(tc);
		} catch (DispositionReportException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();}
			
			TModel[] d = response.getTModelDetail().getTModelArray();
			System.out.println("gettmodeledet "+d[0].getTModelKey()+" "+d[0].getName().getStringValue());
			
		
	}

	private static void getServiceDetail(UDDIInquireServiceSkeleton p) 
	{
		GetServiceDetailDocument tc = GetServiceDetailDocument.Factory.newInstance();
		GetServiceDetail t = tc.addNewGetServiceDetail();
		
		t.setGeneric("2.0");
		String[] keys = new String[] {"7CAA3890-7F3B-11DB-B890-8DFAC17D520B"}; 
		t.setServiceKeyArray(keys);
		
		ServiceDetailDocument response = null;
		
		try {
			response = p.get_serviceDetail(tc);
		} catch (DispositionReportException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();		
		}
		
		BusinessService[] s = response.getServiceDetail().getBusinessServiceArray();
		System.out.println("getservicedet "+s[0].getServiceKey()+" "+s[0].getNameArray()[0].getStringValue());
	}

	private static void getBusinessDetail(UDDIInquireServiceSkeleton p) 
	{
		GetBusinessDetailDocument tc = GetBusinessDetailDocument.Factory.newInstance();
		GetBusinessDetail t = tc.addNewGetBusinessDetail();
		
		t.setGeneric("2.0");
		String[] keys = new String[] {"8E6D5D50-7E5A-11DB-9D50-F920C6F3D06D"}; 
		t.setBusinessKeyArray(keys);
		
		BusinessDetailDocument response = null;
		try {
			response = p.get_businessDetail(tc);
		} catch (DispositionReportException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println("MainClientInq xml beans: find business");
		System.out.println(response.getBusinessDetail().getGeneric());
		BusinessEntity[] info = response.getBusinessDetail().getBusinessEntityArray();
		System.out.println("getbizdet: businessKey is: "+info[0].getBusinessKey());
		System.out.println("getbizdet: business name: "+info[0].getNameArray()[0].getStringValue());
		
		
	}

	private static void getBindingDetail(UDDIInquireServiceSkeleton p) 
	{
		GetBindingDetailDocument tc = GetBindingDetailDocument.Factory.newInstance();
		GetBindingDetail t = tc.addNewGetBindingDetail();
		
		t.setGeneric("2.0");
		String[] keys = new String[] {}; 
		t.setBindingKeyArray(keys);
		BindingDetailDocument d = null;
		try {
			d = p.get_bindingDetail(tc);
		} catch (DispositionReportException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		BindingTemplate[] det = d.getBindingDetail().getBindingTemplateArray();
		System.out.println("binding key: "+det[0].getBindingKey());
		System.out.println("service key: "+det[0].getServiceKey());
		System.out.println("access point: "+det[0].getAccessPoint().getStringValue());
	}

	private static void findRelatedBusinesses(UDDIInquireServiceSkeleton p) 
	{
		FindRelatedBusinessesDocument tc = FindRelatedBusinessesDocument.Factory.newInstance();
		FindRelatedBusinesses t = tc.addNewFindRelatedBusinesses();
		
		t.setGeneric("2.0");
		t.setBusinessKey("8E6D5D50-7E5A-11DB-9D50-F920C6F3D06D");
		
		RelatedBusinessesListDocument l = null;
		try {
			l = p.find_relatedBusinesses(tc);
		} catch (DispositionReportException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		RelatedBusinessInfo[] info = l.getRelatedBusinessesList().getRelatedBusinessInfos().getRelatedBusinessInfoArray();
		System.out.println("find related businesses "+info.length);
		
	}

	private static void findBinding(UDDIInquireServiceSkeleton p) 
	{
		FindBindingDocument tc = FindBindingDocument.Factory.newInstance();
		FindBinding t = tc.addNewFindBinding();
		
		t.setGeneric("2.0");
		t.setServiceKey("7CAA3890-7F3B-11DB-B890-8DFAC17D520B");
		
		BindingDetailDocument d = null;
		
		try {
			d = p.find_binding(tc);
		} catch (DispositionReportException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		BindingTemplate[] det = d.getBindingDetail().getBindingTemplateArray();
		System.out.println("binding key: "+det[0].getBindingKey());
		System.out.println("access point: "+det[0].getAccessPoint().getStringValue());
	}

	private static void findTModel(UDDIInquireServiceSkeleton p) 
	{
		FindTModelDocument tc = FindTModelDocument.Factory.newInstance();
		FindTModel t = tc.addNewFindTModel();
		
		//set generic
		t.setGeneric("2.0");

		//setName
		Name m = Name.Factory.newInstance();
		m.setStringValue("tmodel_binding");
		t.setName(m);
		
		TModelListDocument response = null;
		
		try {
			response = p.find_tModel(tc);
		} catch (DispositionReportException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		TModelList l = response.getTModelList();
		TModelInfo[] tm = response.getTModelList().getTModelInfos().getTModelInfoArray();
		System.out.println("tmodel found: "+tm.length);
		System.out.println("tmodel key: "+tm[0].getTModelKey());
		System.out.println("tmodel name: "+tm[0].getName().getStringValue());
	}

	private static void findService(UDDIInquireServiceSkeleton p) 
	{
		FindServiceDocument tc = FindServiceDocument.Factory.newInstance();
		FindService t = tc.addNewFindService();
		
		//set generic
		t.setGeneric("2.0");
		
		//setName
		Name m = Name.Factory.newInstance();
		m.setStringValue("Service100");
		Name[] array = new Name[1];
		array[0] = m;
		t.setNameArray(array);
		
		//set entity key
		//t.setBusinessKey("8E6D5D50-7E5A-11DB-9D50-F920C6F3D06D");
		
		ServiceListDocument response = null;
		try {
			response = p.find_service(tc);
	
		System.out.println("MainClientInq xml beans: find service");
		uddi_org.api_v2.ServiceList l = response.getServiceList();
		if (l == null) {System.out.println("servicelist null"); return;}
		
		uddi_org.api_v2.ServiceInfos i = l.getServiceInfos();
		if (i == null) {System.out.println("serviceinfos null"); return;}
		
		ServiceInfo[] s = i.getServiceInfoArray();
		if (s == null || (s.length==0))
		{
			System.out.println("serviceinfo array null or 0 elements");
			return;
		}
		System.out.println(s.length);
		System.out.println("service key "+s[0].getServiceKey());
		System.out.println("service name "+s[0].getNameArray(0).getStringValue());
		} catch (DispositionReportException e) {e.printStackTrace();}
	}

	private static void findBusiness(UDDIInquireServiceSkeleton p)
	{
		//test
		FindBusinessDocument tc = FindBusinessDocument.Factory.newInstance();
		FindBusiness t = tc.addNewFindBusiness();
		
		//set generic
		t.setGeneric("2.0");
		
		//setName
		Name m = Name.Factory.newInstance();
		m.setStringValue("BusinessEntity100");
		Name[] array = new Name[1];
		array[0] = m;
		t.setNameArray(array);
		
		//set findQualifiers
		FindQualifiers qual = FindQualifiers.Factory.newInstance();
		String[] ar = new String[] {"exactNameMatch"};
		qual.setFindQualifierArray(ar);
		t.setFindQualifiers(qual);
		
		BusinessListDocument response = null;
		try {
			response = p.find_business(tc);
		} catch (DispositionReportException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println("MainClientInq xml beans: find business");
		System.out.println(response.getBusinessList().getGeneric());
		BusinessInfo[] info = response.getBusinessList().getBusinessInfos().getBusinessInfoArray();
		System.out.println("size: "+info.length);
		System.out.println("businessKey is: "+info[0].getBusinessKey());
		System.out.println("business name: "+info[0].getNameArray()[0].getStringValue());
		
	}



}
