package uddi_org.uddi_client;


import uddi_org.service.DispositionReportException;
import uddi_org.publication_v2.UDDIPublishServiceSkeleton;
import uddi_org.api_v2.*;
import uddi_org.service.Constants;

public class MainClientPublish {

	public static void main(String args[])
	{
		UDDIPublishServiceSkeleton p = new UDDIPublishServiceSkeleton();

		//getAuthToken(p);
		//saveBusiness(p);
		//saveService(p);
		saveTModel(p, "uuid:7A159F30-F514-11DB-B748-B24A710C04FB");
		//saveBinding(p);
		//discartAuthToken(p);

	}

	private static void saveBusiness(UDDIPublishServiceSkeleton stub) 
	{
		SaveBusinessDocument req = SaveBusinessDocument.Factory.newInstance();
		SaveBusiness p = req.addNewSaveBusiness();

		p.setAuthInfo(getAuthToken(stub));
		//p.setAuthInfo("hello");

		p.setGeneric("2.0");
		BusinessEntity b = BusinessEntity.Factory.newInstance();
		Name n = Name.Factory.newInstance();
		n.setStringValue("BusinessEntity39");
		//n.setLang("eng");

		Name[] namearray = new Name[] {n};

		b.setNameArray(namearray);
		b.setBusinessKey("");

		BusinessEntity[] array = new BusinessEntity[] {b}; 
		p.setBusinessEntityArray(array);

		BusinessDetailDocument d = null;

		req.setSaveBusiness(p);

		try {
			d = stub.save_business(req);
		} catch (DispositionReportException e) 
		{
			DispositionReportDocument t = e.getFaultMessage();
			Result g = t.getDispositionReport().getResultArray()[0];
			System.out.println("DispositionReportEx: "+ g.getErrInfo().getStringValue()+ " "+g.getErrno() );
			return;

		}
		if(d == null) {System.out.println("d null"); return;}

		if(d.getBusinessDetail() == null) {System.out.println("bis detail null"); return;}

		BusinessEntity[] be = d.getBusinessDetail().getBusinessEntityArray();
		if(be.length == 0) {
			System.out.println("bus array null"); return;} 
		System.out.println(be.length);
		System.out.println("biz key "+d.getBusinessDetail().getBusinessEntityArray()[0].getBusinessKey());
		System.out.println("biz name "+d.getBusinessDetail().getBusinessEntityArray()[0].getNameArray()[0].getStringValue());
		System.out.println("response: "+d.toString());

	}

	private static void saveService(UDDIPublishServiceSkeleton stub) 
	{
		try {
			ServiceDetailDocument d = null;

			SaveServiceDocument req = SaveServiceDocument.Factory.newInstance();
			SaveService p = req.addNewSaveService();

			p.setAuthInfo(getAuthToken(stub));
			p.setGeneric("2.0");

			/*//////////////////////////////////
			
			BindingTemplate temp = BindingTemplate.Factory.newInstance();

			AccessPoint ap = AccessPoint.Factory.newInstance();
			ap.setStringValue("www.myservice.com:8080/services/testedservice");
			ap.setURLType(URLType.HTTP);
			temp.setAccessPoint(ap);

			temp.setServiceKey("92E55A10-D600-11DB-A613-C2E730A67EE7");
			temp.setBindingKey("");

			TModelInstanceDetails tmid = TModelInstanceDetails.Factory.newInstance();

			//binding tmodel
			TModelInstanceInfo info = TModelInstanceInfo.Factory.newInstance();
			info.setTModelKey("uuid:2DB43680-D604-11DB-A613-D2E501B92092");
			InstanceDetails id = InstanceDetails.Factory.newInstance();
//			OverviewDoc doc = OverviewDoc.Factory.newInstance();
//			doc.setOverviewURL("www.servce.com/s.wsdl");
//			id.setOverviewDoc(doc);
			id.setInstanceParms("port");
			info.setInstanceDetails(id);

			//portType tmodel
			TModelInstanceInfo info1 = TModelInstanceInfo.Factory.newInstance();
			info1.setTModelKey("uuid:8A411A90-D603-11DB-A613-FE48BFBBF3AD");



			TModelInstanceInfo[] tmiia = new TModelInstanceInfo[] {info, info1};
			tmid.setTModelInstanceInfoArray(tmiia);
			temp.setTModelInstanceDetails(tmid);

			BindingTemplate[] tarray = new BindingTemplate[] {temp};
			/////////////////////////////////
			*/
			
			
			BusinessService c = BusinessService.Factory.newInstance();

			Name name = Name.Factory.newInstance();
			name.setStringValue("Service03");
			Name[] narray = new Name[] {name};
			c.setNameArray(narray);

			c.setBusinessKey("260FBEC0-D0AC-11DB-BEC0-A0197F8C08E8");

			CategoryBag cb = CategoryBag.Factory.newInstance();
			KeyedReference key = KeyedReference.Factory.newInstance();
			key.setKeyName("service local name");
			key.setKeyValue("Service");
			KeyedReference[] keys = new KeyedReference[] {key};   
			cb.setKeyedReferenceArray(keys);
			c.setCategoryBag(cb);
			
			BindingTemplates bts =  BindingTemplates.Factory.newInstance();
			//bts.setBindingTemplateArray(tarray);
			c.setBindingTemplates(bts);

			BusinessService[] array = new BusinessService[] {c};
					
			
			p.setBusinessServiceArray(array);
			req.setSaveService(p);

			d = stub.save_service(req);
			System.out.println("service key "+d.getServiceDetail().getBusinessServiceArray()[0].getServiceKey());

		} catch (DispositionReportException e) {
			e.printStackTrace();
			DispositionReportDocument tt = e.getFaultMessage();
			if (tt != null) {
				System.out.println(tt.getDispositionReport().getResultArray().length);

				Result g = tt.getDispositionReport().getResultArray()[0];
				System.out.println((g.getKeyType()));

			System.out.println("DispositionReportEx: "+ g.getErrInfo().getStringValue()+ " "+g.getErrno()+ g.getErrInfo().getErrCode() );
		}
	}

	catch (Exception e) {e.printStackTrace();}
}

private static void saveBinding(UDDIPublishServiceSkeleton stub)
{
	try {
		BindingDetailDocument d = null;
		SaveBindingDocument tc = SaveBindingDocument.Factory.newInstance();
		SaveBinding t = tc.addNewSaveBinding();

		t.setGeneric("2.0");
		t.setAuthInfo(getAuthToken(stub));

		BindingTemplate temp = BindingTemplate.Factory.newInstance();

		AccessPoint ap = AccessPoint.Factory.newInstance();
		ap.setStringValue("www.myservice.com:8080/services/testedservice");
		ap.setURLType(URLType.HTTP);
		temp.setAccessPoint(ap);

		temp.setServiceKey("4EEDE190-F4A7-11DB-A190-8CDCE79E50D8");
		temp.setBindingKey("");

		TModelInstanceDetails tmid = TModelInstanceDetails.Factory.newInstance();

//		portType tmodel
		TModelInstanceInfo pt = TModelInstanceInfo.Factory.newInstance();
		pt.setTModelKey("uuid:444B8860-F40B-11DB-8860-B481F3F0426C");

		//binding tmodel
		TModelInstanceInfo bind = TModelInstanceInfo.Factory.newInstance();
		bind.setTModelKey("uuid:39616B30-F448-11DB-AB30-EE7C4AF500E9");
		InstanceDetails id = InstanceDetails.Factory.newInstance();
		id.setInstanceParms("ciaoPort");
		bind.setInstanceDetails(id);

		//service tmodel
		TModelInstanceInfo service = TModelInstanceInfo.Factory.newInstance();
		service.setTModelKey("uuid:13ABFFE0-F44D-11DB-BFE0-F883AA65090D");

		//ssm tmodel
		TModelInstanceInfo ssm = TModelInstanceInfo.Factory.newInstance();
		ssm.setTModelKey("uuid:D434D5F0-F413-11DB-95F0-A5EF051A0E77");

		TModelInstanceInfo[] tmiia = new TModelInstanceInfo[] {pt, bind, service, ssm};
		tmid.setTModelInstanceInfoArray(tmiia);



		
		temp.setTModelInstanceDetails(tmid);

		BindingTemplate[] tarray = new BindingTemplate[] {temp};
		
		t.setBindingTemplateArray(tarray);
		tc.setSaveBinding(t);

		d = stub.save_binding(tc);

		//System.out.println("main client "+d.toString());
		//System.out.println("BindingTemplate: " +d.getBindingDetail().getBindingTemplateArray()[0].getBindingKey());


	} catch (DispositionReportException e) {
		DispositionReportDocument tt = e.getFaultMessage();
		Result g = tt.getDispositionReport().getResultArray()[0];
		System.out.println("DispositionReportException:");
		System.out.println("Result[0]:\n errno: "+ g.getErrno()+"\n keyType: "+g.getKeyType() +"\n errinfo:errcode "+g.getErrInfo().getErrCode()+"\n errinfo: "+g.getErrInfo().getStringValue());
	}

	catch (Exception e) {System.out.println("Exception"); e.printStackTrace();}
}

private static void saveTModel(UDDIPublishServiceSkeleton stub, String tmodelkey) 
{
	try {

		TModelDetailDocument d = null;
		SaveTModelDocument tc = SaveTModelDocument.Factory.newInstance();
		SaveTModel t = tc.addNewSaveTModel();

		t.setGeneric("");
		t.setAuthInfo(getAuthToken(stub));

		TModel tmodel = TModel.Factory.newInstance();

		//set name
		Name name = Name.Factory.newInstance();
		//name.setStringValue("tmodel_portType");
		name.setStringValue("tmodel_binding70");
		tmodel.setName(name);

		//set tmodel key
		tmodel.setTModelKey("");

		//set ov doc
		OverviewDoc od = OverviewDoc.Factory.newInstance();
		od.setOverviewURL("www.myservice.com/service.wsdl");
		tmodel.setOverviewDoc(od);

		//set
		CategoryBag cb = CategoryBag.Factory.newInstance();
		KeyedReference key1 = KeyedReference.Factory.newInstance();
		key1.setKeyName("WSDL type");
		key1.setKeyValue(Constants.BINDING);
		key1.setTModelKey(Constants.WSDL_ENTITY_TYPE_TMODELKEY);
		KeyedReference key2 = KeyedReference.Factory.newInstance();
		key2.setKeyName("uddi-org:types");
		key2.setKeyValue("wsdlSpec");
		key2.setTModelKey(Constants.UDDI_ORG_TYPES_TMODELKEY);

		KeyedReference[] keys = new KeyedReference[] {key1, key2};   
		cb.setKeyedReferenceArray(keys);
		tmodel.setCategoryBag(cb);

		TModel[] tarray = new TModel[] {tmodel};
		t.setTModelArray(tarray);

		d = stub.save_tModel(tc);
		System.out.println("Mainclient tmodel "+ d.getTModelDetail().getTModelArray()[0].getTModelKey());

	} catch (DispositionReportException e) {
		DispositionReportDocument tt = e.getFaultMessage();
		Result g = tt.getDispositionReport().getResultArray()[0];
		System.out.println("DispositionReportEx: "+ g.getErrInfo().getStringValue()+ " "+g.getErrno() );
		return;}

	catch (Exception e) {e.printStackTrace();}
}

private static String getAuthToken(UDDIPublishServiceSkeleton p) 
{
	GetAuthTokenDocument tc = GetAuthTokenDocument.Factory.newInstance();
	GetAuthToken t = tc.addNewGetAuthToken();
	t.setUserID("JUDDI");
	t.setCred("");
	t.setGeneric("");
	AuthTokenDocument response = null;
	try {
		response = p.get_authToken(tc);
	} catch (DispositionReportException e) {
		DispositionReportDocument tt = e.getFaultMessage();
		Result g = tt.getDispositionReport().getResultArray()[0];
		System.out.println("DispositionReportEx: "+ g.getErrInfo().getStringValue()+ " "+g.getErrno() );
		return null;
	}
	/*System.out.println("MainClient xml beans");
		System.out.println(response.getAuthToken().getAuthInfo());
		System.out.println(response.getAuthToken().getGeneric());
		System.out.println(response.getAuthToken().getOperator());
	 */
	//test: discard_authToken
	/*DiscardAuthTokenDocument d = DiscardAuthTokenDocument.Factory.newInstance();
		DiscardAuthToken dt = d.addNewDiscardAuthToken();
		dt.setAuthInfo(response.getAuthToken().getAuthInfo());
		DispositionReportDocument resp = p.discard_authToken(d);
		System.out.println("Dispo report: "+resp.getDispositionReport().getResultArray(0));*/

	//
	return response.getAuthToken().getAuthInfo();

}

private static void discartAuthToken(UDDIPublishServiceSkeleton stub) 
{
	try {
		DiscardAuthTokenDocument req = DiscardAuthTokenDocument.Factory.newInstance();
		DiscardAuthToken p = req.addNewDiscardAuthToken();

		p.setGeneric("");
		p.setAuthInfo(getAuthToken(stub));

		DispositionReportDocument d = stub.discard_authToken(req);

		Result[] r = d.getDispositionReport().getResultArray();
		Result g = r[0];
		System.out.println("DispositionReport: "+ g.getErrInfo().getStringValue()+ " "+g.getErrInfo().getErrCode());

	} catch (DispositionReportException e) {
		DispositionReportDocument tt = e.getFaultMessage();
		//e.printStackTrace();

		Result g = tt.getDispositionReport().getResultArray()[0];
		System.out.println("DispositionReportEx: "+ g.getErrInfo().getErrCode()+ " "+g.getErrno() );
		return;}

	catch (Exception e) {e.printStackTrace();}
}

}
