package utils;

import java.util.Vector;

import org.uddi4j.datatype.binding.BindingTemplates;
import org.uddi4j.datatype.service.BusinessService;
import org.uddi4j.response.ServiceDetail;
import org.uddi4j.response.ServiceInfo;
import org.uddi4j.response.ServiceList;
import org.uddi4j.util.CategoryBag;

/**
 * @author faith
 *
 * Feb 26, 2007  1:31:24 AM
 *
 */
public class BusinessService_TypeMapping {
	
	public static Vector toVectorBusinessService (uddi_org.api_v2.BusinessService[] array)
	{
		Vector v = new Vector();
		uddi_org.api_v2.BusinessService service = null;
		BusinessService a = null;
		
		for(int i=0;i<array.length;i++)
		{
			service = array[i];
			a = new BusinessService();
			
			//set attributes
			a.setServiceKey(service.getServiceKey());
			a.setBusinessKey(service.getBusinessKey());
			
			//set name vector
			a.setNameVector(Util_TypeMapping.toVectorN(service.getNameArray()));
			
			//set description vector
			a.setDescriptionVector(Util_TypeMapping.toVectorD(service.getDescriptionArray()));
			
			//set bindingTemplates
			BindingTemplates b = new BindingTemplates();
		
			if ((service.getBindingTemplates())!=null)
				b.setBindingTemplateVector(BindingTemplate_TypeMapping.toVector(service.getBindingTemplates().getBindingTemplateArray()));
			a.setBindingTemplates(b);
			
			
//			//set categoryBag
			CategoryBag cat = new CategoryBag();
			Vector vv = new Vector();
			if(service.getCategoryBag() != null)
				vv = Util_TypeMapping.toVectorKeyedReference(service.getCategoryBag().getKeyedReferenceArray());
			cat.setKeyedReferenceVector(vv);
			a.setCategoryBag(cat);
			
		
			v.add(a);
		}
		return v;
	}
	
	public static uddi_org.api_v2.BusinessService[] toArrayBusinessService(Vector v)
	{
		uddi_org.api_v2.BusinessService[] array = new uddi_org.api_v2.BusinessService[v.size()];
		
		uddi_org.api_v2.BusinessService service = null;
		BusinessService a = null;
		
		for(int i=0;i<v.size();i++)
		{
			a = (BusinessService) v.elementAt(i);
			service = uddi_org.api_v2.BusinessService.Factory.newInstance();
			
			//set attributes
			service.setServiceKey(a.getServiceKey());
			service.setBusinessKey(a.getBusinessKey());
			
			//set name
			service.setNameArray(Util_TypeMapping.toArrayN(a.getNameVector()));
			
			//set description
			service.setDescriptionArray(Util_TypeMapping.toArrayD(a.getDescriptionVector()));
			
			//set binding templates
			uddi_org.api_v2.BindingTemplates  bind = uddi_org.api_v2.BindingTemplates.Factory.newInstance();
			bind.setBindingTemplateArray(BindingTemplate_TypeMapping.toArray(a.getBindingTemplates().getBindingTemplateVector()));
			service.setBindingTemplates(bind);
			
			//set category bag
			uddi_org.api_v2.CategoryBag bag =  uddi_org.api_v2.CategoryBag.Factory.newInstance();
			
			Vector b = null;		
			if (a.getCategoryBag() != null)
				b= a.getCategoryBag().getKeyedReferenceVector();
			
			bag.setKeyedReferenceArray(Util_TypeMapping.toArrayKeyedReference(b));
			service.setCategoryBag(bag);
			
			array[i]=service;
		}
		
		return array;
	}

	public static uddi_org.api_v2.ServiceDetail transformServiceDetail(ServiceDetail d) 
	{
		uddi_org.api_v2.ServiceDetail detail = uddi_org.api_v2.ServiceDetail.Factory.newInstance();
		
		//set attributes
		detail.setGeneric(d.GENERIC);
		detail.setOperator(d.getOperator());
		if (d.getTruncatedBoolean() == true)
			detail.setTruncated(uddi_org.api_v2.Truncated.TRUE);
		else 
			detail.setTruncated(uddi_org.api_v2.Truncated.FALSE);
		
		//set businessServiceArray
		detail.setBusinessServiceArray(toArrayBusinessService(d.getBusinessServiceVector()));
		
		return detail;
	}

	public static uddi_org.api_v2.ServiceInfo[] toArrayServiceInfo(Vector v) 
	{
		uddi_org.api_v2.ServiceInfo[] array = new uddi_org.api_v2.ServiceInfo[v.size()];
		
		
		for(int i=0;i<v.size();i++)
		{
			array[i] = transformServiceInfo((ServiceInfo)v.elementAt(i));
		}
		return array;
	}

	public static uddi_org.api_v2.ServiceInfo transformServiceInfo (ServiceInfo s)
	{
		if (s == null)
			return null;
		else
		{
		uddi_org.api_v2.ServiceInfo service = uddi_org.api_v2.ServiceInfo.Factory.newInstance();
		
		//set attributes serviceKey, businessKey
		service.setBusinessKey(s.getBusinessKey());
		service.setServiceKey(s.getServiceKey());
		
		//set nameArray
		uddi_org.api_v2.Name[] n = null;
		if(s.getNameVector() != null)
		{
			n = Util_TypeMapping.toArrayN(s.getNameVector());
		}
		service.setNameArray(n);
		
		return service;
		}
	}

	public static uddi_org.api_v2.ServiceList transformServiceList(ServiceList l) 
	{
		if(l == null)
			return null;
		else 
		{		
			uddi_org.api_v2.ServiceList list = uddi_org.api_v2.ServiceList.Factory.newInstance();

			//set generic, operator, truncated attributes
			list.setGeneric(l.GENERIC);
			list.setOperator(l.getOperator());
			if (l.getTruncatedBoolean() == true)
				list.setTruncated(uddi_org.api_v2.Truncated.TRUE);
			else 
				list.setTruncated(uddi_org.api_v2.Truncated.FALSE);

			//set serviceInfos
			uddi_org.api_v2.ServiceInfos s = uddi_org.api_v2.ServiceInfos.Factory.newInstance();

			//null checking
			uddi_org.api_v2.ServiceInfo[] info = null;
			if ((l.getServiceInfos().getServiceInfoVector()) != null)
			{

				info = toArrayServiceInfo(l.getServiceInfos().getServiceInfoVector());
			}

			s.setServiceInfoArray(info);
			list.setServiceInfos(s);

			return list;
		}
	}
}
