package utils;

import java.util.Vector;

import org.uddi4j.datatype.OverviewDoc;
import org.uddi4j.datatype.binding.InstanceDetails;
import org.uddi4j.datatype.binding.InstanceParms;
import org.uddi4j.datatype.binding.TModelInstanceInfo;
import org.uddi4j.datatype.tmodel.TModel;
import org.uddi4j.response.TModelDetail;
import org.uddi4j.response.TModelInfo;
import org.uddi4j.response.TModelInfos;
import org.uddi4j.response.TModelList;
import org.uddi4j.util.CategoryBag;
import org.uddi4j.util.IdentifierBag;
import org.uddi4j.util.TModelBag;


/**
 * @author faith
 *
 * Feb 26, 2007  1:31:10 AM
 *
 */
public class TModel_TypeMapping {

	public static Vector toVectorTM(uddi_org.api_v2.TModel[] array) 
	{
		Vector v = new Vector();
		
		uddi_org.api_v2.TModel tmodel = null;
		TModel t = null;
		
		for(int i=0; i<array.length; i++)
		{
			t = new TModel();
			tmodel = array[i];
			
			//set attributes authorizedName, operator, tmodelkey 
			t.setAuthorizedName(tmodel.getAuthorizedName());
			t.setOperator(tmodel.getOperator());
			t.setTModelKey(tmodel.getTModelKey());
			
			//set name
			t.setName(Util_TypeMapping.transformName(tmodel.getName()));
			
			//set description
			t.setDescriptionVector(Util_TypeMapping.toVectorD(tmodel.getDescriptionArray()));
			
			//set overviewdoc
			t.setOverviewDoc(Util_TypeMapping.transformOverviwDoc(tmodel.getOverviewDoc()));	
			
			//set identifierBag
			IdentifierBag iden = new IdentifierBag();
			Vector vv = new Vector();
			if(tmodel.getIdentifierBag() != null)
				vv = Util_TypeMapping.toVectorKeyedReference(tmodel.getIdentifierBag().getKeyedReferenceArray());
			iden.setKeyedReferenceVector(vv);
			t.setIdentifierBag(iden);

			//set categoryBag
			CategoryBag cat = new CategoryBag();
			vv = new Vector();
			if(tmodel.getCategoryBag() != null)
				vv = Util_TypeMapping.toVectorKeyedReference(tmodel.getCategoryBag().getKeyedReferenceArray());
			cat.setKeyedReferenceVector(vv);
			t.setCategoryBag(cat);
			
			
			v.add(t);
		}
		
		return v;
	}

	public static Vector toVectorTMInstanceInfo(uddi_org.api_v2.TModelInstanceInfo[] array) 
	{
		Vector v = new Vector();

		TModelInstanceInfo info = null;
		uddi_org.api_v2.TModelInstanceInfo t= null;
		for(int i=0;i<array.length;i++)
		{
			t = array[i];
			info = new TModelInstanceInfo();
			
			info.setTModelKey(t.getTModelKey());
			
			if(t.getDescriptionArray() != null)
				info.setDescriptionVector(Util_TypeMapping.toVectorD(t.getDescriptionArray()));
			
			if(t.getInstanceDetails() !=null)
				info.setInstanceDetails(transformInstanceDetails(t.getInstanceDetails()));
			
			v.add(info);
		}
		return v;
	}

	public static InstanceDetails transformInstanceDetails(uddi_org.api_v2.InstanceDetails d) 
	{
		InstanceDetails i = new InstanceDetails();
		
		if(d.getDescriptionArray() != null)
			i.setDescriptionVector(Util_TypeMapping.toVectorD(d.getDescriptionArray()));
		
		if(d.getOverviewDoc() != null)
			i.setOverviewDoc(Util_TypeMapping.transformOverviwDoc(d.getOverviewDoc()));
		
		if(d.getInstanceParms() != null)
			i.setInstanceParms(new InstanceParms(d.getInstanceParms()));
		
		return i;
	}
	
	public static uddi_org.api_v2.InstanceDetails transformInstanceDetails(InstanceDetails d)
	{
		uddi_org.api_v2.InstanceDetails details = uddi_org.api_v2.InstanceDetails.Factory.newInstance();
		
		//set description
		if (d.getDescriptionVector() != null)
			details.setDescriptionArray(Util_TypeMapping.toArrayD(d.getDescriptionVector()));
		
		//set ovDoc
		if(d.getOverviewDoc() != null)
		details.setOverviewDoc(Util_TypeMapping.transformOverviwDoc(d.getOverviewDoc()));
		
		//set instanceParms
		if (d.getInstanceParms() != null)
		details.setInstanceParms(d.getInstanceParms().getText());
		
		return details;
	}

	public static uddi_org.api_v2.TModelDetail transformTModelDetail(TModelDetail d) 
	{
		uddi_org.api_v2.TModelDetail t = uddi_org.api_v2.TModelDetail.Factory.newInstance();
		
		//set attributes
		t.setGeneric(d.GENERIC);
		t.setOperator(d.getOperator());
		if (d.getTruncatedBoolean() == true)
			t.setTruncated(uddi_org.api_v2.Truncated.TRUE);
		else 
			t.setTruncated(uddi_org.api_v2.Truncated.FALSE);
		
		//set tModel
		t.setTModelArray(toArray(d.getTModelVector()));
		
		return t;
	}
	
	public static uddi_org.api_v2.TModel[] toArray (Vector v)
	{
		uddi_org.api_v2.TModel[] array = new uddi_org.api_v2.TModel[v.size()];
		
		uddi_org.api_v2.TModel model =  null;
		TModel m = null;
		
		for(int i=0; i<v.size(); i++)
		{
			m = (TModel) v.elementAt(i);
			model = uddi_org.api_v2.TModel.Factory.newInstance();
			
			model.setAuthorizedName(m.getAuthorizedName());
			model.setOperator(m.getOperator());
			model.setTModelKey(m.getTModelKey());
			
			model.setName(Util_TypeMapping.transformName(m.getName()));
			
			model.setDescriptionArray(Util_TypeMapping.toArrayD(m.getDescriptionVector()));
			
			model.setOverviewDoc(Util_TypeMapping.transformOverviwDoc(m.getOverviewDoc()));
			
			//set identifierbag
			uddi_org.api_v2.IdentifierBag id = uddi_org.api_v2.IdentifierBag.Factory.newInstance();
			
			Vector vv = null;
			
			if(m.getIdentifierBag() != null)
				vv = m.getIdentifierBag().getKeyedReferenceVector();
			
			id.setKeyedReferenceArray(Util_TypeMapping.toArrayKeyedReference(vv));
			model.setIdentifierBag(id);
			
			//set categorybag
			uddi_org.api_v2.CategoryBag cat =uddi_org.api_v2.CategoryBag.Factory.newInstance();
			
			vv = null;
			
			if(m.getCategoryBag() != null )
				vv = m.getCategoryBag().getKeyedReferenceVector();
				
			cat.setKeyedReferenceArray(Util_TypeMapping.toArrayKeyedReference(vv));
			model.setCategoryBag(cat);
			
			array[i] = model;
		}
		
		return array;
	}

	public static TModelBag transformTModelBag(uddi_org.api_v2.TModelBag t) 
	{
		TModelBag bag = new TModelBag();
		
		Vector v = new Vector();
		String[] array = t.getTModelKeyArray();
		
		for(int i=0; i<array.length; i++)
		{
			v.add(array[i]);
		}
		
		bag.setTModelKeyStrings(v);
		return bag;
	}
	
	public static uddi_org.api_v2.TModelList transformTModelList(TModelList t)
	{
		uddi_org.api_v2.TModelList l = uddi_org.api_v2.TModelList.Factory.newInstance();
		
		//set operator and truncated attributes
		l.setOperator(t.getOperator());
		
		if (t.getTruncatedBoolean() == true)
			l.setTruncated(uddi_org.api_v2.Truncated.TRUE);
		else 
			l.setTruncated(uddi_org.api_v2.Truncated.FALSE);
		
		//set TModelInfos
		uddi_org.api_v2.TModelInfos s = uddi_org.api_v2.TModelInfos.Factory.newInstance();
		s.setTModelInfoArray(toArrayTModelInfo(t.getTModelInfos().getTModelInfoVector()));
		l.setTModelInfos(s);
		
		return l;
	}

	public static uddi_org.api_v2.TModelInfo[] toArrayTModelInfo(Vector v) 
	{
		uddi_org.api_v2.TModelInfo[] array = new uddi_org.api_v2.TModelInfo[v.size()];
		
		uddi_org.api_v2.TModelInfo info = null;
		TModelInfo in = null;
		
		for(int i=0; i<array.length; i++)
		{
			info = uddi_org.api_v2.TModelInfo.Factory.newInstance();
			in = (TModelInfo) v.elementAt(i);
			
			info.setName(Util_TypeMapping.transformName(in.getName()));
			info.setTModelKey(in.getTModelKey());
			
			array[i] = info;
		}
		return array;
	}
	
	public static uddi_org.api_v2.TModelInstanceInfo[] toArrayTModelInstanceInfo(Vector v)
	{
		uddi_org.api_v2.TModelInstanceInfo[] array = new uddi_org.api_v2.TModelInstanceInfo[v.size()];
		uddi_org.api_v2.TModelInstanceInfo t = null;
		TModelInstanceInfo m = null;
		
		for(int i=0; i<v.size(); i++)
		{
			m = (TModelInstanceInfo) v.elementAt(i);
			t = uddi_org.api_v2.TModelInstanceInfo.Factory.newInstance();
			
			//set attribute
			t.setTModelKey(m.getTModelKey());
			
			//set description
			t.setDescriptionArray(Util_TypeMapping.toArrayD(m.getDescriptionVector()));
			
			//set InstanceDetails
			if(m.getInstanceDetails() != null)
				t.setInstanceDetails(TModel_TypeMapping.transformInstanceDetails(m.getInstanceDetails()));
			
			array[i] = t;
		}
		
		return array;
	}

}
