package uddi_org.uddi_client;

import java.rmi.RemoteException;

import javax.xml.namespace.QName;

import org.apache.axis2.AxisFault;
//import org.apache.axis2.Constants;
import org.apache.axis2.addressing.EndpointReference;
import org.apache.axis2.client.Options;
import org.apache.axis2.client.ServiceClient;

import uddi_org.api_v2.AccessPoint;
import uddi_org.api_v2.AuthToken;
import uddi_org.api_v2.AuthTokenDocument;
import uddi_org.api_v2.BindingDetailDocument;
import uddi_org.api_v2.BindingTemplate;
import uddi_org.api_v2.BusinessDetailDocument;
import uddi_org.api_v2.BusinessEntity;
import uddi_org.api_v2.BusinessService;
import uddi_org.api_v2.CategoryBag;
import uddi_org.api_v2.Description;
import uddi_org.api_v2.DiscardAuthToken;
import uddi_org.api_v2.DiscardAuthTokenDocument;
import uddi_org.api_v2.DispositionReportDocument;
import uddi_org.api_v2.GetAuthToken;
import uddi_org.api_v2.GetAuthTokenDocument;
import uddi_org.api_v2.InstanceDetails;
import uddi_org.api_v2.KeyedReference;
import uddi_org.api_v2.Name;
import uddi_org.api_v2.OverviewDoc;
import uddi_org.api_v2.Result;
import uddi_org.api_v2.SaveBinding;
import uddi_org.api_v2.SaveBindingDocument;
import uddi_org.api_v2.SaveBusiness;
import uddi_org.api_v2.SaveBusinessDocument;
import uddi_org.api_v2.SaveTModel;
import uddi_org.api_v2.SaveTModelDocument;
import uddi_org.api_v2.ServiceDetailDocument;
import uddi_org.api_v2.SaveService;
import uddi_org.api_v2.SaveServiceDocument;
import uddi_org.api_v2.TModel;
import uddi_org.api_v2.TModelDetailDocument;
import uddi_org.api_v2.TModelInstanceDetails;
import uddi_org.api_v2.TModelInstanceInfo;
import uddi_org.api_v2.URLType;
import uddi_org.publication_v2.DispositionReportException;
import uddi_org.publication_v2.PublishSoapServiceStub;

import uddi_org.uddi_client.Constants;


/**
 * @author faith
 *
 * @date Feb 17, 2007, 2:18:22 PM
 * 
 */
public class PublishClient{
	public static AuthToken t = null;
	public static String info= null;


	public static void main(java.lang.String args[]){
		try{
			String hostname = "localhost";
			String serviceName = "UDDIPublishService";
			String myName = "http://localhost:8080/axis2/services/clientService1";

			PublishSoapServiceStub stub = new PublishSoapServiceStub("http://localhost:8080/axis2/services/"+ serviceName);

			ServiceClient s = stub._getServiceClient();
			s.engageModule(new QName(org.apache.axis2.Constants.MODULE_ADDRESSING));
			Options options = new Options();
			options.setTo(new EndpointReference ("http://"+hostname+":8080/axis2/services/"+serviceName));
			options.setFrom((new EndpointReference(myName)));
			s.setOptions(options);


			t = getAuthToken(stub);
			//saveBusiness(stub);
			//saveService(stub);
			//saveTModel(stub);
			//saveTModel(stub);
			//saveBinding(stub);
			//discartAuthToken(stub);
			
			
		} catch(Exception e){e.printStackTrace();}
	}

	private static void discartAuthToken(PublishSoapServiceStub stub) 
	{
		try {
			DiscardAuthTokenDocument req = DiscardAuthTokenDocument.Factory.newInstance();
			DiscardAuthToken p = req.addNewDiscardAuthToken();
			
			p.setGeneric("");
			p.setAuthInfo(getAuthToken(stub).getAuthInfo());

			DispositionReportDocument d = stub.discard_authToken(req);
			Result[] r = d.getDispositionReport().getResultArray();
			Result g = r[0];
			System.out.println("DispositionReport: "+ g.getErrno()+ " "+g.getErrInfo().getErrCode());

		} catch (DispositionReportException e) {
			DispositionReportDocument tt = e.getFaultMessage();
			//e.printStackTrace();
			
			Result g = tt.getDispositionReport().getResultArray()[0];
			System.out.println("DispositionReportEx: "+ g.getErrInfo().getErrCode()+ " "+g.getErrno() );
			return;}

		catch (Exception e) {e.printStackTrace();}
	}

	private static void saveBinding(PublishSoapServiceStub stub)
	{
		try {
			BindingDetailDocument d = null;
			SaveBindingDocument tc = SaveBindingDocument.Factory.newInstance();
			SaveBinding t = tc.addNewSaveBinding();

			t.setGeneric("2.0");
			//t.setAuthInfo(getAuthToken(stub).getAuthInfo());
			t.setAuthInfo("authToken:485581B0-FFAD-11DB-81B0-F0A58C74B476");

			BindingTemplate temp = BindingTemplate.Factory.newInstance();

			AccessPoint ap = AccessPoint.Factory.newInstance();
			ap.setStringValue("www.myservice.com:8080/services/service15.26");
			ap.setURLType(URLType.HTTP);
			temp.setAccessPoint(ap);

			temp.setServiceKey("07DFB530-FFB0-11DB-B530-90C79E1BD92F");
			//temp.setBindingKey("3EBCE630-FFA7-11DB-A630-E5D6743B2410");

			TModelInstanceDetails tmid = TModelInstanceDetails.Factory.newInstance();

			//binding tmodel
			TModelInstanceInfo info = TModelInstanceInfo.Factory.newInstance();
			info.setTModelKey("uuid:01ABB140-F511-11DB-B748-93F266015C20");
			InstanceDetails id = InstanceDetails.Factory.newInstance();
//			OverviewDoc doc = OverviewDoc.Factory.newInstance();
//			doc.setOverviewURL("www.servce.com/s.wsdl");
//			id.setOverviewDoc(doc);
			id.setInstanceParms("port");
			info.setInstanceDetails(id);

			//portType tmodel
			TModelInstanceInfo info1 = TModelInstanceInfo.Factory.newInstance();
			info1.setTModelKey("uuid:0194A6D0-F511-11DB-B748-9ACE969C2FDA");

			//service tmodel
			TModelInstanceInfo info2 = TModelInstanceInfo.Factory.newInstance();
			info2.setTModelKey("uuid:01BD1660-F511-11DB-B748-BA7B946787BD");
			
			TModelInstanceInfo info3 = TModelInstanceInfo.Factory.newInstance();
			info2.setTModelKey("uuid:017D7550-F511-11DB-B748-D41E3749E12F");
			
			TModelInstanceInfo[] tmiia = new TModelInstanceInfo[] {info, info1, info2, info3};
			tmid.setTModelInstanceInfoArray(tmiia);
			temp.setTModelInstanceDetails(tmid);
			
			BindingTemplate[] tarray = new BindingTemplate[] {temp};
			
			t.setBindingTemplateArray(tarray);
			tc.setSaveBinding(t);

			d = stub.save_binding(tc);

			System.out.println("main client "+d.toString());
			
			System.out.println("BindingTemplate: " +d.getBindingDetail().getBindingTemplateArray()[0].getBindingKey());

		} catch (DispositionReportException e) {
			DispositionReportDocument tt = e.getFaultMessage();
			//e.printStackTrace();
			
			Result g = tt.getDispositionReport().getResultArray()[0];
			System.out.println("DispositionReportEx: "+ g.getErrInfo().getErrCode()+ " "+g.getErrno() );
			return;}

		catch (Exception e) {e.printStackTrace();}
	}
	
	private static void saveService(PublishSoapServiceStub stub) 
	{
		
		try {
			ServiceDetailDocument d = null;

			SaveServiceDocument req = SaveServiceDocument.Factory.newInstance();
			SaveService p = req.addNewSaveService();

			p.setAuthInfo(getAuthToken(stub).getAuthInfo());
			p.setGeneric("2.0");

			BusinessService c = BusinessService.Factory.newInstance();
			Name name = Name.Factory.newInstance();
			name.setStringValue("Service11");
			Name[] narray = new Name[] {name};
			c.setNameArray(narray);
			
			c.setBusinessKey("260FBEC0-D0AC-11DB-BEC0-A0197F8C08E8");
			//c.setServiceKey("5D447B20-00B2-11DC-BB20-D8BAC8F9207D");
			
			BusinessService[] array = new BusinessService[] {c};
			p.setBusinessServiceArray(array);
			req.setSaveService(p);

			d = stub.save_service(req);
			System.out.println("service key"+d.getServiceDetail().getBusinessServiceArray()[0].getServiceKey());
		} catch (DispositionReportException e) {
			DispositionReportDocument tt = e.getFaultMessage();
			Result g = tt.getDispositionReport().getResultArray()[0];
			System.out.println("DispositionReportEx: "+ g.getErrInfo().getStringValue()+ " "+g.getErrno() );
			return;}

		catch (Exception e) {e.printStackTrace();}

	}

	private static void saveBusiness(PublishSoapServiceStub stub)
	{
		BusinessDetailDocument d = null;
		try {

			SaveBusinessDocument req = SaveBusinessDocument.Factory.newInstance();
			SaveBusiness p = req.addNewSaveBusiness();

			//p.setAuthInfo("authToken:86885D10-CF18-11DB-9D10-8A13CDD136C3");
			p.setAuthInfo(getAuthToken(stub).getAuthInfo());
			//p.setAuthInfo(t.getAuthInfo());
			p.setGeneric("2.0");

			BusinessEntity b = BusinessEntity.Factory.newInstance();
			
			Name n = Name.Factory.newInstance();
			n.setStringValue("BusinessEntity100");
			//n.setLang("en-US");
			Name[] namearray = new Name[] {n};
			b.setNameArray(namearray);
			
			/*Description des = Description.Factory.newInstance();
			des.setStringValue("descrizione100");
			Description[] darray = new Description[] {des};
			b.setDescriptionArray(darray);
			*/
			b.setBusinessKey("");

			BusinessEntity[] array = new BusinessEntity[] {b}; 
			p.setBusinessEntityArray(array);

			req.setSaveBusiness(p);

			d = stub.save_business(req);
			BusinessEntity[] be = d.getBusinessDetail().getBusinessEntityArray();
			if(be.length == 0) {
				System.out.println("b null"); return;}
			System.out.println(be.length);
			System.out.println("biz key "+d.getBusinessDetail().getBusinessEntityArray()[0].getBusinessKey());
			System.out.println("biz name "+d.getBusinessDetail().getBusinessEntityArray()[0].getNameArray()[0].getStringValue());
			System.out.println("Hello!");
		} catch (DispositionReportException e) {
			DispositionReportDocument tt = e.getFaultMessage();
			Result g = tt.getDispositionReport().getResultArray()[0];
			System.out.println("DispositionReportEx: "+ g.getErrInfo().getStringValue()+ " "+g.getErrno() );
			return;}

		catch (Exception e) {e.printStackTrace();}
	}

	private static void saveTModel(PublishSoapServiceStub stub) 
	{
		try {
			
		TModelDetailDocument d = null;
		SaveTModelDocument tc = SaveTModelDocument.Factory.newInstance();
		SaveTModel t = tc.addNewSaveTModel();
		
		t.setGeneric("");
		//t.setAuthInfo(getAuthToken(stub).getAuthInfo());
		t.setAuthInfo("authToken:FB6A2EF0-FF9D-11DB-AEF0-D9D513642232");
		
		TModel tmodel = TModel.Factory.newInstance();
		
		//set name
		Name name = Name.Factory.newInstance();
		name.setStringValue("tmodel_bind71");
		tmodel.setName(name);
		
		//set tmodel key
		tmodel.setTModelKey("");
		
		//set ov doc
		OverviewDoc od = OverviewDoc.Factory.newInstance();
		od.setOverviewURL("www.myservice.com/service.wsdl");
		tmodel.setOverviewDoc(od);

		CategoryBag cb = CategoryBag.Factory.newInstance();
		KeyedReference key1 = KeyedReference.Factory.newInstance();
		key1.setKeyName("WSDL type");
		key1.setKeyValue(Constants.SERVICE);
		key1.setTModelKey(Constants.WSDL_ENTITY_TYPE_TMODELKEY);
	
		

		KeyedReference[] keys = new KeyedReference[] {key1};   
		cb.setKeyedReferenceArray(keys);
		tmodel.setCategoryBag(cb);
		
			
		TModel[] tarray = new TModel[] {tmodel};
		t.setTModelArray(tarray);
		
		d = stub.save_tModel(tc);
		System.out.println("tmodel"+ d.getTModelDetail().getTModelArray()[0].getTModelKey());
		
		} catch (DispositionReportException e) {
			DispositionReportDocument tt = e.getFaultMessage();
			Result g = tt.getDispositionReport().getResultArray()[0];
			System.out.println("DispositionReportEx: "+ g.getErrInfo().getStringValue()+ " "+g.getErrno() );
			return;}

		catch (Exception e) {
			System.out.println("Except...");
			e.printStackTrace();}
	}
	
	private static AuthToken getAuthToken(PublishSoapServiceStub stub)
	{

		AuthTokenDocument res = null;

		try {
			GetAuthTokenDocument req = GetAuthTokenDocument.Factory.newInstance();

			GetAuthToken p = req.addNewGetAuthToken();

			p.setUserID("juddi");
			p.setCred("federica");
			p.setGeneric("2.0");

			res = stub.get_authToken(req);

			System.out.println("Publish client - Client class generated with xmlbeans");
			System.out.println(res.getAuthToken().getAuthInfo());
			System.out.println(res.getAuthToken().getGeneric());
			System.out.println(res.getAuthToken().getOperator());

		} catch (DispositionReportException e) {
			DispositionReportDocument tt = e.getFaultMessage();
			Result g = tt.getDispositionReport().getResultArray()[0];
			System.out.println("DispositionReportEx: "+ g.getErrInfo().getStringValue()+ " "+g.getErrno() );
			return null;}

		catch (Exception e) {System.out.println("Dis");e.printStackTrace(); return null;}
		return res.getAuthToken();
	}

}
