package uddi_org.uddi_client;

import javax.xml.namespace.QName;

import org.apache.axis2.Constants;
import org.apache.axis2.addressing.EndpointReference;
import org.apache.axis2.client.Options;
import org.apache.axis2.client.ServiceClient;

import uddi_org.api_v2.AccessPoint;
import uddi_org.api_v2.AuthToken;
import uddi_org.api_v2.AuthTokenDocument;
import uddi_org.api_v2.BindingDetailDocument;
import uddi_org.api_v2.BindingTemplate;
import uddi_org.api_v2.BindingTemplates;
import uddi_org.api_v2.BusinessDetailDocument;
import uddi_org.api_v2.BusinessEntity;
import uddi_org.api_v2.BusinessService;
import uddi_org.api_v2.BusinessServices;
import uddi_org.api_v2.CategoryBag;
import uddi_org.api_v2.DispositionReportDocument;
import uddi_org.api_v2.GetAuthToken;
import uddi_org.api_v2.GetAuthTokenDocument;
import uddi_org.api_v2.InstanceDetails;
import uddi_org.api_v2.KeyedReference;
import uddi_org.api_v2.Name;
import uddi_org.api_v2.OverviewDoc;
import uddi_org.api_v2.Result;
import uddi_org.api_v2.SaveBinding;
import uddi_org.api_v2.SaveBindingDocument;
import uddi_org.api_v2.SaveBusiness;
import uddi_org.api_v2.SaveBusinessDocument;
import uddi_org.api_v2.SaveService;
import uddi_org.api_v2.SaveServiceDocument;
import uddi_org.api_v2.SaveTModel;
import uddi_org.api_v2.SaveTModelDocument;
import uddi_org.api_v2.ServiceDetailDocument;
import uddi_org.api_v2.TModel;
import uddi_org.api_v2.TModelDetailDocument;
import uddi_org.api_v2.TModelInstanceDetails;
import uddi_org.api_v2.TModelInstanceInfo;
import uddi_org.api_v2.URLType;
import uddi_org.publication_v2.DispositionReportException;
import uddi_org.publication_v2.PublishSoapServiceStub;


public class PublishWSDL {

	private AuthToken t = null;
	private String info = null;
	private PublishSoapServiceStub stub = null;

	private String portType_tmodelkey = null;
	private String binding_tmodelkey = null;
	private String ssminstance_tmodelkey = null;
	private String service_tmodelkey = null;
	private CategoryBag service_categorybag = null;
	private String bindingTemplatekey = null;
	private String servicekey = null;
	private String businessEntitykey = null;
	private String port = null;

	public PublishWSDL(){
		try{
			String hostname = "localhost";
			String serviceName = "UDDIPublishService";
			String myName = "http://localhost:8080/axis2/services/clientService1";

			stub = new PublishSoapServiceStub("http://localhost:8080/axis2/services/"+ serviceName);

			ServiceClient s = stub._getServiceClient();
			s.engageModule(new QName(Constants.MODULE_ADDRESSING));
			Options options = new Options();
			options.setTo(new EndpointReference ("http://"+hostname+":8080/axis2/services/"+serviceName));
			options.setFrom((new EndpointReference(myName)));
			s.setOptions(options);
			t = this.getAuthToken();
		} catch(Exception e){e.printStackTrace();}
	}

	public static void main(String[] args)
	{
		PublishWSDL p = new PublishWSDL();
		p.getAuthToken();
		p.bindingTemplatekey = "879EEB00-18F7-11DC-A494-C65A7636CB2C";
		p.servicekey = "4AC2EE70-18F7-11DC-A494-B06EA141DE96";
		//p.service_categorybag = getServiceCategoryBag("ns", "service local name");
		
		p.portType_tmodelkey = "uuid:5D762860-18EE-11DC-A860-B2567500E99A";
		p.ssminstance_tmodelkey ="uuid:5D57CAF0-18EE-11DC-8AF0-9BA8E3CC03DF";
		
		p.binding_tmodelkey = "uuid:5D80FDD0-18EE-11DC-BDD0-B49139FC5CB9";
		p.service_tmodelkey = "uuid:5D8FCAE0-18EE-11DC-8AE0-D35CEA1854D2";
		
		p.businessEntitykey = "26AF6110-01F7-11DC-A110-C943627215E4";
		
		//p.bindingTemplatekey = 

		System.out.println(p.save_SSM_tModel(p.ssminstance_tmodelkey, "Supplier1", "http://cs.tu-berlin.de/~lf/supplier1_1.xml"));

		System.out.println(p.save_portType_tModel(p.portType_tmodelkey, "Supplier1", "http://sel.isti.cnr.it/", "http://pc-dispo5:8080/PlasticApplications/Supplier1Service?WSDL", p.ssminstance_tmodelkey));

		System.out.println(p.save_binding_tModel(p.binding_tmodelkey, "Supplier1PortBinding", "http://sel.isti.cnr.it/", null, null,"http://pc-dispo5:8080/PlasticApplications/Supplier1Service?WSDL"));

		System.out.println(p.save_service_tModel(p.service_tmodelkey, "Supplier1Service", "http://sel.isti.cnr.it/", "http://pc-dispo5:8080/PlasticApplications/Supplier1Service?WSDL"));
		
		
		//save empty business entity
		//p.save_business("", "business12", null);
		//System.out.println("-------------------------------------------------------");
		
		//save *empty* service
		//p.save_service(p.servicekey, p.businessEntitykey, "Supplier1Service12", null);	
		//BusinessService s = p.save_service("", p.businessEntitykey, "Supplier1Service18", null);
		//System.out.println(s.toString());
		//System.out.println("-------------------------------------------------------");
		
		//save bt
		//---BindingTemplate t = p.save_bindingTemplate(p.bindingTemplatekey, p.servicekey, "Supplier1Port", "http://pc-dispo5:8080/PlasticApplications/Supplier1Service");
		//---System.out.println(p.bindingTemplatekey);
		//System.out.println("-------------------------------------------------------");
		
		//update service
		//System.out.println(p.save_service(p.servicekey, p.businessEntitykey, "Supplier1Service20", t));	
		//BusinessService ss = p.save_service(p.servicekey, p.businessEntitykey, "Supplier1Service18", t);
		//System.out.println(p.servicekey);

		//System.out.println("-------------------------------------------------------");
		//p.save_business(p.businessEntitykey, "business18", ss);
	}

	public void save_business(String businesskey, String businessname, BusinessService s)
	{
		BusinessDetailDocument d = null;
		try {

			SaveBusinessDocument req = SaveBusinessDocument.Factory.newInstance();
			SaveBusiness p = req.addNewSaveBusiness();

			p.setAuthInfo(this.getAuthToken().getAuthInfo());
			p.setGeneric("2.0");

			BusinessEntity b = BusinessEntity.Factory.newInstance();
			
			Name n = Name.Factory.newInstance();
			n.setStringValue(businessname);
			Name[] namearray = new Name[] {n};
			b.setNameArray(namearray);
			
			if (businesskey == null)
				b.setBusinessKey("");
			else b.setBusinessKey(businesskey);

			if(s != null) {
				BusinessServices services = BusinessServices.Factory.newInstance();
				BusinessService[] servicearray = new BusinessService[]{s};
				services.setBusinessServiceArray(servicearray);
				b.setBusinessServices(services);
			}

			BusinessEntity[] array = new BusinessEntity[] {b}; 
			p.setBusinessEntityArray(array);

			req.setSaveBusiness(p);

			d = stub.save_business(req);
			System.out.println(d.toString());
			
			
			if(b==null) {
				System.out.println("b null"); return;}
			BusinessEntity[] be = d.getBusinessDetail().getBusinessEntityArray();
			if(be.length == 0) {
				System.out.println("be null"); return;}
			System.out.println(be.length);
			System.out.println("biz key "+d.getBusinessDetail().getBusinessEntityArray()[0].getBusinessKey());
			System.out.println("biz name "+d.getBusinessDetail().getBusinessEntityArray()[0].getNameArray()[0].getStringValue());
			this.businessEntitykey = d.getBusinessDetail().getBusinessEntityArray()[0].getBusinessKey();

		} catch (DispositionReportException e) {
			DispositionReportDocument tt = e.getFaultMessage();
	
			Result[] r = tt.getDispositionReport().getResultArray();
			System.out.println("Ddfsa"+ r.length);
			Result g = tt.getDispositionReport().getResultArray()[0];
			System.out.println("DispositionReportEx: "+ g.getErrInfo().getStringValue()+ " "+g.getErrno() );
			System.out.println("DispositionReportEx ");
			e.printStackTrace();
			return;}
		catch (Exception e) {e.printStackTrace();}
	}
	
	public String save_tModel(String tmodelkey, String tmodelname, String ow, CategoryBag cb)
	{
		String portType_tmodelkey = null;

		try {

			TModelDetailDocument d = null;
			SaveTModelDocument tc = SaveTModelDocument.Factory.newInstance();
			SaveTModel t = tc.addNewSaveTModel();

			t.setGeneric("");
			t.setAuthInfo(this.getAuthToken().getAuthInfo());

			TModel tmodel = TModel.Factory.newInstance();

			//set name
			Name name = Name.Factory.newInstance();
			name.setStringValue(tmodelname);
			tmodel.setName(name);

			//set tmodel key
			if(tmodelkey != null)
				tmodel.setTModelKey(tmodelkey);
			else 
				tmodel.setTModelKey("");

			//set ov doc
			OverviewDoc od = OverviewDoc.Factory.newInstance();
			od.setOverviewURL(ow);
			tmodel.setOverviewDoc(od);

			//set category bag
			tmodel.setCategoryBag(cb);

			TModel[] tarray = new TModel[] {tmodel};
			t.setTModelArray(tarray);

			d = stub.save_tModel(tc);
			portType_tmodelkey = d.getTModelDetail().getTModelArray()[0].getTModelKey();
			//System.out.println("tmodel"+ portType_tmodelkey);

		} catch (DispositionReportException e) {
			DispositionReportDocument tt = e.getFaultMessage();
			Result g = tt.getDispositionReport().getResultArray()[0];
			System.out.println("DispositionReportEx: "+ g.getErrInfo().getStringValue()+ " "+g.getErrno() );
			return null;}

		catch (Exception e) {e.printStackTrace();}	

		return portType_tmodelkey;
	}

	public String save_portType_tModel(String tmodelkey, String portTypename, String ns, String owdoc, String SSMtmodelkey)
	{
		CategoryBag cb = CategoryBag.Factory.newInstance();

		//namespace
		KeyedReference k1 = createKR(ClientConstants.XML_NAMESPACE_TMODELKEY, ClientConstants.XML_NAMESPACE_KEYNAME, ns);

		//WSDL entity type
		KeyedReference k2 = createKR(ClientConstants.WSDL_ENTITY_TYPE_TMODELKEY, ClientConstants.WSDL_ENTITY_TYPE_KEYNAME, ClientConstants.PORT_TYPE);

		//SSM reference
		KeyedReference k3 = createKR(ClientConstants.SSM_REFERENCE_TMODELKEY, ClientConstants.SSM_REFERENCE_KEYNAME, SSMtmodelkey);

		KeyedReference[] krarray = new KeyedReference[] {k1, k2, k3};
		cb.setKeyedReferenceArray(krarray);

		this.portType_tmodelkey = this.save_tModel(tmodelkey, portTypename, owdoc, cb);

		return this.portType_tmodelkey;
	}


	public String save_SSM_tModel(String tmodelkey, String portTypename, String owdoc)
	{

		CategoryBag cb = CategoryBag.Factory.newInstance();

		//specification
		KeyedReference k1 = createKR(ClientConstants.UDDI_ORG_TYPES_TMODELKEY, ClientConstants.UDDI_ORG_TYPES_KEYNAME, ClientConstants.SPECIFICATION);

		//ssm
		KeyedReference k2 =createKR(ClientConstants.SSM_SPECIFICATION_TMODELKEY, ClientConstants.SSM_SPECIFICATION_KEYNAME, ClientConstants.SSM);

		KeyedReference[] krarray = new KeyedReference[] {k1, k2};

		cb.setKeyedReferenceArray(krarray);

		this.ssminstance_tmodelkey = this.save_tModel(tmodelkey, portTypename, owdoc, cb);

		return this.ssminstance_tmodelkey;
	}

	public String save_binding_tModel(String tmodelkey, String bindingname, String ns, String protocoltmodelkey, String transporttmodelkey, String owdoc)
	{
		//namespace
		KeyedReference k1 = createKR(ClientConstants.XML_NAMESPACE_TMODELKEY, ClientConstants.XML_NAMESPACE_KEYNAME, ns);

		//WSDL entity
		KeyedReference k2 = createKR(ClientConstants.WSDL_ENTITY_TYPE_TMODELKEY, ClientConstants.WSDL_ENTITY_TYPE_KEYNAME, ClientConstants.BINDING);

		//portType reference
		KeyedReference k3 = createKR(ClientConstants.WSDL_PORTTYPE_REFERENCE_TMODELKEY, ClientConstants.WSDL_PORTTYPE_REFERENCE_KEYNAME, this.portType_tmodelkey);

		//protocol
		KeyedReference k4 = createKR(ClientConstants.PROTOCOL_CATEGORIZATION_TMODELKEY, ClientConstants.SOAP_PROTOCOL_KEYNAME, ClientConstants.SOAP_PROTOCOL_TMODELKEY);

		//transport
		KeyedReference k5 = createKR(ClientConstants.TRANSPORT_CATEGORIZATION_TMODELKEY, ClientConstants.HTTP_TRANSPORT_KEYNAME, ClientConstants.HTTP_TRANSPORT_TMODELKEY);

		//wsdlSpec
		KeyedReference k6 = createKR(ClientConstants.UDDI_ORG_TYPES_TMODELKEY, ClientConstants.UDDI_ORG_TYPES_KEYNAME, ClientConstants.WSDL_SPEC);

		KeyedReference[] krarray = new KeyedReference[] {k1, k2, k3, k4, k5, k6};

		CategoryBag cb = CategoryBag.Factory.newInstance();
		cb.setKeyedReferenceArray(krarray);
		this.binding_tmodelkey = this.save_tModel(tmodelkey, bindingname, owdoc, cb);

		return this.binding_tmodelkey;
	}

	public String save_service_tModel(String tmodelkey, String servicelocalname, String ns, String owdoc )
	{
		//namespace
		KeyedReference k1 = createKR(ClientConstants.XML_NAMESPACE_TMODELKEY, ClientConstants.XML_NAMESPACE_KEYNAME, ns);

		//WSDL entity
		KeyedReference k2 = createKR(ClientConstants.WSDL_ENTITY_TYPE_TMODELKEY, ClientConstants.WSDL_ENTITY_TYPE_KEYNAME, ClientConstants.SERVICE);

		//service local name
		KeyedReference k3 = createKR(ClientConstants.XML_LOCAL_NAME_TMODELKEY, ClientConstants.XML_LOCAL_NAME_KEYNAME, servicelocalname);

		KeyedReference[] krarray = new KeyedReference[] {k1, k2, k3};

		CategoryBag cb = CategoryBag.Factory.newInstance();
		cb.setKeyedReferenceArray(krarray);
		this.service_categorybag = cb;

		this.service_tmodelkey = this.save_tModel(tmodelkey, servicelocalname, owdoc, cb);  

		return this.service_tmodelkey;
	}

	public BusinessService save_service(String skey, String bekey, String servicename, BindingTemplate bt)
	{
		BusinessService s= null;
		try {
			ServiceDetailDocument d = null;

			SaveServiceDocument req = SaveServiceDocument.Factory.newInstance();
			SaveService p = req.addNewSaveService();

			p.setAuthInfo(this.getAuthToken().getAuthInfo());
			p.setGeneric(" ");

			BusinessService c = BusinessService.Factory.newInstance();

			//set name
			Name name = Name.Factory.newInstance();
			name.setStringValue(servicename);
			Name[] narray = new Name[] {name};
			c.setNameArray(narray);

			//set servicekey
			if(skey !=null)
				c.setServiceKey(skey);
			else
				c.setServiceKey("");

			//set businesskey
			c.setBusinessKey(bekey);

			//set binding templates
			if(bt != null) 
			{
				BindingTemplates templs = BindingTemplates.Factory.newInstance();
				
				BindingTemplate[] templa = new BindingTemplate[] {bt};
				templs.setBindingTemplateArray(templa);
				c.setBindingTemplates(templs);
			}

			//set categorybag
			c.setCategoryBag(this.service_categorybag);

			BusinessService[] array = new BusinessService[] {c};
			p.setBusinessServiceArray(array);
			req.setSaveService(p);

			d = stub.save_service(req);
			System.out.println(d.toString());

			this.servicekey = d.getServiceDetail().getBusinessServiceArray()[0].getServiceKey();
			s = d.getServiceDetail().getBusinessServiceArray()[0];

		} catch (DispositionReportException e) {
			DispositionReportDocument tt = e.getFaultMessage();
			Result g = tt.getDispositionReport().getResultArray()[0];
			System.out.println("DispositionReportEx: "+ g.getErrInfo().getStringValue()+ " "+g.getErrno() );
			return null;}

		catch (Exception e) {e.printStackTrace();}

		return s;
	}

	public BindingTemplate save_bindingTemplate(String bindingTemplayekey, String skey, String portname, String ap)
	{
		this.port = portname;
		TModelInstanceDetails tmid = TModelInstanceDetails.Factory.newInstance();

		//portType tmodel
		TModelInstanceInfo pt = TModelInstanceInfo.Factory.newInstance();
		pt.setTModelKey(this.portType_tmodelkey);

		//binding tmodel
		TModelInstanceInfo bind = TModelInstanceInfo.Factory.newInstance();
		bind.setTModelKey(this.binding_tmodelkey);
		InstanceDetails id = InstanceDetails.Factory.newInstance();
		id.setInstanceParms(portname);
		bind.setInstanceDetails(id);

		//service tmodel
		TModelInstanceInfo service = TModelInstanceInfo.Factory.newInstance();
		service.setTModelKey(this.service_tmodelkey);

		//ssm tmodel
		TModelInstanceInfo ssm = TModelInstanceInfo.Factory.newInstance();
		ssm.setTModelKey(this.ssminstance_tmodelkey);

		TModelInstanceInfo[] tmiia = new TModelInstanceInfo[] {pt, bind, service, ssm};
		tmid.setTModelInstanceInfoArray(tmiia);

		BindingTemplate bt = this.save_bindingTemplatelocal(bindingTemplayekey, skey, ap, tmid);
		//this.bindingTemplatekey = bt.getBindingKey();

		return bt;
	}

	public BindingTemplate save_bindingTemplatelocal(String bindingtkey, String skey, String accesspoint, TModelInstanceDetails tmid)
	{
		BindingDetailDocument d = BindingDetailDocument.Factory.newInstance();
		try {

			SaveBindingDocument tc = SaveBindingDocument.Factory.newInstance();
			SaveBinding t = tc.addNewSaveBinding();

			t.setGeneric(" ");
			t.setAuthInfo(this.getAuthToken().getAuthInfo());

			BindingTemplate temp = BindingTemplate.Factory.newInstance();

			//set AccessPoint
			AccessPoint ap = AccessPoint.Factory.newInstance();
			ap.setStringValue(accesspoint);
			ap.setURLType(URLType.HTTP);
			temp.setAccessPoint(ap);

			//set servicekey
			temp.setServiceKey(skey);

			//set bindingkey
			if(bindingtkey != null)
				temp.setBindingKey(bindingtkey);
			else
				temp.setBindingKey("");

			//set tmodelinstancedetails
			temp.setTModelInstanceDetails(tmid);

			BindingTemplate[] tarray = new BindingTemplate[] {temp};

			t.setBindingTemplateArray(tarray);
			tc.setSaveBinding(t);
			
			if(tc == null) {System.out.println("tc null");}

			d = this.stub.save_binding(tc);
			System.out.println(d.toString());
			
			if(d.getBindingDetail().getBindingTemplateArray().length == 0) {System.out.println("d null"); return null;}

			//System.out.println("main client "+d.toString());
			this.bindingTemplatekey = d.getBindingDetail().getBindingTemplateArray()[0].getBindingKey();

			//System.out.println("BindingTemplate: " +d.getBindingDetail().getBindingTemplateArray()[0].getBindingKey());

			return d.getBindingDetail().getBindingTemplateArray()[0];
			
		} catch (DispositionReportException e) {
			e.printStackTrace();
			DispositionReportDocument tt = e.getFaultMessage();
			//Result g = tt.getDispositionReport().getResultArray()[0];
			//System.out.println("DispositionReportEx: "+ g.getErrInfo().getErrCode()+ " "+g.getErrno() );
			System.out.println("result element "+ tt.toString());
			//e.printStackTrace();
			return null;}
		catch (Exception e) {System.out.println("ex"); e.printStackTrace(); return null;}

		
	}

	public AuthToken getAuthToken()
	{
		AuthTokenDocument res = null;
		
		if(this.t == null) {

		try {
			GetAuthTokenDocument req = GetAuthTokenDocument.Factory.newInstance();

			GetAuthToken p = req.addNewGetAuthToken();

			p.setUserID("juddi");
			p.setCred("federica");
			p.setGeneric("2.0");

			res = stub.get_authToken(req);
		} catch (DispositionReportException e) {
			DispositionReportDocument tt = e.getFaultMessage();
			Result g = tt.getDispositionReport().getResultArray()[0];
			System.out.println("DispositionReportEx: "+ g.getErrInfo().getStringValue()+ " "+g.getErrno() );
			return null;}

		catch (Exception e) {e.printStackTrace();}
		this.t = res.getAuthToken();
		return res.getAuthToken();}
		
		else
			return this.t;
	}

	//static utils methods
	public static KeyedReference createKR(String tmodelkey, String keyname, String keyvalue)
	{
		KeyedReference r1 = KeyedReference.Factory.newInstance();
		r1.setTModelKey(tmodelkey);
		r1.setKeyName(keyname);
		r1.setKeyValue(keyvalue);

		return r1;
	}
	
	public static CategoryBag getServiceCategoryBag(String ns, String servicelocalname)
	{
//		namespace
		KeyedReference k1 = createKR(ClientConstants.XML_NAMESPACE_TMODELKEY, ClientConstants.XML_NAMESPACE_KEYNAME, ns);

		//WSDL entity
		KeyedReference k2 = createKR(ClientConstants.WSDL_ENTITY_TYPE_TMODELKEY, ClientConstants.WSDL_ENTITY_TYPE_KEYNAME, ClientConstants.SERVICE);

		//service local name
		KeyedReference k3 = createKR(ClientConstants.XML_LOCAL_NAME_TMODELKEY, ClientConstants.XML_LOCAL_NAME_KEYNAME, servicelocalname);

		KeyedReference[] krarray = new KeyedReference[] {k1, k2, k3};

		CategoryBag cb = CategoryBag.Factory.newInstance();
		cb.setKeyedReferenceArray(krarray);
		
		return cb;
	}

}
